#!/bin/bash

source /opt/iacheck/bin/common_def/GlobalVariable.sh
source ${DATA_PATH}/bin/common_def/IACheckResultOutput.sh
source ${DATA_PATH}/bin/common_def/IACheckUtils.sh
source ${DATA_PATH}/bin/common_def/RecordPorgress.sh

#加载通用业务检测
source ${DATA_PATH}/bin/bus_check/IamCommonBussiness.sh
source ${DATA_PATH}/bin/bus_check/IaeCommonBussiness.sh
source ${DATA_PATH}/bin/bus_check/MqBalanceBussiness.sh
#加载环境巡检项
source ${DATA_PATH}/bin/env_check/chek_item/coredumpCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/cpuCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/diskCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/memoryCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/netStatusCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/ssdCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/zombieProcessesCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/chipPasswordFreeCheck.sh
source ${DATA_PATH}/bin/env_check/AxEnvironment.sh
source ${DATA_PATH}/bin/env_check/GpuEnvironment.sh
source ${DATA_PATH}/bin/env_check/HisiEnvironment.sh
source ${DATA_PATH}/bin/env_check/IamEnvironment.sh
source ${DATA_PATH}/bin/env_check/MluEnvironment.sh
#新增巡检项
source ${DATA_PATH}/bin/env_check/chek_item/dmesgCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/logLevelCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/libReplaceCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/syncTimeCheck.sh
source ${DATA_PATH}/bin/env_check/chek_item/ioCheck.sh

### 加载数据库文件
LoadCheckDbFile()
{
   LOG 1 "开始加载数据库文件"
   local db_engine_load_result=` sqlite3 ${CHECK_DB_FILE} "CREATE TABLE IF NOT EXISTS ia_engine(ip TEXT PRIMARY KEY, port TEXT, username TEXT, passwd TEXT);" `
   local db_config_load_result=` sqlite3 ${CHECK_DB_FILE} "CREATE TABLE IF NOT EXISTS check_config(item TEXT PRIMARY KEY, value TEXT);" `
   LOG 1 "数据库文件加载完成"
}

### 移除用不到的ssh登录信息
RemoveSshInfo()
{
    local remove_ssh=""
    local iae_ip_in_iam=` sqlite3 ${IAS_DB} "SELECT address FROM ia_engine GROUP BY address" `
    local arr_iae_ip_in_iam=(${iae_ip_in_iam})
	local hitsory_iae_ip=` sqlite3 ${CHECK_DB_FILE} "SELECT ip FROM ia_engine" `
    local arr_history_iae_ip_info=(${hitsory_iae_ip})
    for history_iae_ip in "${arr_history_iae_ip_info[@]}"
    do
        local need_remove_ssh_info="true"
        for iae_ip_in_iam in "${arr_iae_ip_in_iam[@]}"
        do
            if [ "${history_iae_ip}" == "${iae_ip_in_iam}" ]
            then
                need_remove_ssh_info="false"
            fi
        done
        if [ "true" == "${need_remove_ssh_info}" ]
        then
            cmd=` sqlite3 ${CHECK_DB_FILE} "DELETE FROM ia_engine WHERE ip='${history_iae_ip}';" `
            LOG 0 "${history_iae_ip} 登录信息已被移除"
        fi
    done
}

### 加载ssh登录信息
LoadIaeIpAndPasswd()
{ 
    LOG 1 "开始加载ssh登录信息"
	# 移除iam上未挂载的板卡登录信息
	RemoveSshInfo
    local iae_in_iam=` sqlite3 ${IAS_DB} "SELECT address FROM ia_engine GROUP BY address" `
	local iae_address_vec=(${iae_in_iam})
    local ssh_port=0
    local ssh_user_name=""
    local ssh_password=""
    # 检验板卡登录信息
	for((index=0; index<${#iae_address_vec[*]}; index++))
	do 
        retry_num=0
	    local current_iae_ip="${iae_address_vec[$index]}"
	    local current_iae_login_info=` sqlite3 ${CHECK_DB_FILE} "SELECT * FROM ia_engine WHERE ip = '${current_iae_ip}';" `
		if [ -z "${current_iae_login_info}" ]
	    then
            # 尝试用上一次输入的密码进行登录，如果登录成功，不在要求用户手动输入登录信息
            timeout 40s ${SSHPASS} -p ${ssh_password} ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -o ConnectTimeout=10 -p ${ssh_port} ${ssh_user_name}@${current_iae_ip} " " &> /dev/null
            if [ $? -eq 0 ]
            then
                local insert_result=` sqlite3 ${CHECK_DB_FILE} "INSERT INTO ia_engine(ip,port,username,passwd) VALUES('${current_iae_ip}','${ssh_port}','${ssh_user_name}','${ssh_password}')" `
                continue
            fi
            
		    # 输入ssh登录信息
		    echo "${current_iae_ip} login info is empty, please input"
		    echo "please input ssh_port: "
			read ssh_port
			echo "please input ssh_user_name: "
		    read ssh_user_name
			echo "please input ssh_password: "
			read ssh_password
			while :
			do
			    timeout 40s ${SSHPASS} -p ${ssh_password} ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -o ConnectTimeout=10 -p ${ssh_port} ${ssh_user_name}@${current_iae_ip} " " &> /dev/null
			    if [ $? -ne 0 ]
		        then
                    retry_num=$(expr $retry_num + 1)
                    if [ $retry_num -ge 2 ]
                    then
                        echo "${current_iae_ip} login failed num: ${retry_num}，will don't be saved"
                        break
                    fi
                    
    			    echo "${current_iae_ip} login info is error, please reset"
	    			echo "please update ssh_port: "
		    	    read ssh_port
			        echo "please update ssh_user_name: "
		            read ssh_user_name
			        echo "please update ssh_password: "
			        read ssh_password
			    else
				    echo "${current_iae_ip} login info will be saved"
				    break
			    fi
                
			done
            if [ $retry_num -lt 2 ]
            then 
                local insert_result=` sqlite3 ${CHECK_DB_FILE} "INSERT INTO ia_engine(ip,port,username,passwd) VALUES('${current_iae_ip}','${ssh_port}','${ssh_user_name}','${ssh_password}')" `
            fi
		else
            # 尝试用上一次输入的密码进行登录，如果登录成功，不在要求用户手动输入登录信息
            timeout 40s ${SSHPASS} -p ${ssh_password} ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -o ConnectTimeout=10 -p ${ssh_port} ${ssh_user_name}@${current_iae_ip} " " &> /dev/null
            if [ $? -eq 0 ]
            then
                local update_result=` sqlite3 ${CHECK_DB_FILE} "UPDATE ia_engine SET port='${ssh_port}', username='${ssh_user_name}', passwd='${ssh_password}' WHERE ip='${current_iae_ip}'" `
                continue
            fi
            
			# iae 登录信息已经保存在了数据库里，则校验ssh登录密码，如不正确，需要手动修改
			local current_iae_login_info_arr=(${current_iae_login_info//|/ })
			local ssh_port=${current_iae_login_info_arr[1]}
			local ssh_user_name=${current_iae_login_info_arr[2]}
			local ssh_user_password=${current_iae_login_info_arr[3]}
			timeout 40s ${SSHPASS} -p "${ssh_user_password}" ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -o ConnectTimeout=10 -p "${ssh_port}" "${ssh_user_name}"@"${current_iae_ip}" " " &> /dev/null
			if [ $? -ne 0 ]
		    then
			    echo "${current_iae_ip} login info is error, please update"
				echo "please update ssh_port: "
			    read ssh_port
			    echo "please update ssh_user_name: "
		        read ssh_user_name
			    echo "please update ssh_password: "
			    read ssh_password
				while :
			    do
			        timeout 40s ${SSHPASS} -p "${ssh_password}" ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -o ConnectTimeout=10 -p "${ssh_port}" "${ssh_user_name}"@"${current_iae_ip}" " " &> /dev/null
			        if [ $? -ne 0 ]
		            then
                        if [ $retry_num -ge 2 ]
                        then
                            echo "${current_iae_ip} login failed num: %{retry_num}，will don't be updated"
                            break
                        fi
    			        echo "${current_iae_ip} login info is error, please reset"
	    			    echo "please update ssh_port: "
		    	        read ssh_port
			            echo "please update ssh_user_name: "
		                read ssh_user_name
			            echo "please update ssh_password: "
			            read ssh_password
					else
					    echo "${current_iae_ip} login info will be updated"
					    break
			        fi
			    done
                if [ $retry_num -lt 2 ]
                then
                    echo "will udpate db"
                    local update_result=` sqlite3 ${CHECK_DB_FILE} "UPDATE ia_engine SET port='${ssh_port}', username='${ssh_user_name}', passwd='${ssh_password}' WHERE ip='${current_iae_ip}'" `
                fi
			fi
		fi
	done
	
}

#### 脚本执行入口
IACheckMain()
{	
	#IAM的巡检项JSON头
	StartIpJsonOutput "IAM"
	
    # 进度相关信息初始化
    ProgressInit "IAM" 0 1 "IAM"
    
	# iam版本信息获取
	local iam_version=$(GetIamVersion)    

    # 最低版本检查
    LOG 0 "开始检查最低版本限制"
    StartCheckItemJsonOutput "${CHECK_SOFT_VERSION_LIMIT}" #开始检查项JSON输出
    IamVersionLimitCheck "${iam_version}"
    IAMUpdateProgress
    EndCheckItemJsonOutput #结束检查项JSON输出
    LOG 0 "结束最低版本限制"
     
    LOG 0 "开始检查IAM pg数据库密码配置"
    StartCheckItemJsonOutput "${CHECK_IAM_PG_PASSWD_CONFIG}" #开始检查项JSON输出
    IamPgPasswordCheck
    IAMUpdateProgress
    EndCheckItemJsonOutput #结束检查项JSON输出
    
	# 巡检iam信息
	LOG 0 "开始IAM业务巡检"
	IamBussinessCheck
	LOG 0 "IAM业务巡检完成"

	# IAM环境巡检项
	LOG 0 "开始IAM环境巡检项：Check_IAM_Coredump"
	StartCheckItemJsonOutput "${CHECK_ENV_ITEM_CORE}" #开始检查项JSON输出
	Check_IAM_Coredump #IAM的core检查
    IAMUpdateProgress
	EndCheckItemJsonOutput #结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_Coredump"
	
	LOG 0 "开始IAM环境巡检项：Check_IAM_Zombie_Processes"
	StartCheckItemJsonOutput "${CHECK_ENV_ITEM_ZOMBIE}" #开始检查项JSON输出
	Check_IAM_Zombie_Processes #IAM的僵尸进程检查
    IAMUpdateProgress
	EndCheckItemJsonOutput #结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_Zombie_Processes"

	LOG 0 "开始IAM环境巡检项：Check_IAM_Disk"
	StartCheckItemJsonOutput "${CHECK_ENV_ITEM_DISK}" #开始检查项JSON输出
	Check_IAM_Disk	#IAM的磁盘空间检
    IAMUpdateProgress
	EndCheckItemJsonOutput #结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_Disk"
	
	LOG 0 "开始IAM环境巡检项：Check_IAM_Mem"
	StartCheckItemJsonOutput "${CHECK_ENV_ITEM_MEMORY}" #开始检查项JSON输出
	Check_IAM_Mem	#IAM的内存检测
    IAMUpdateProgress
	EndCheckItemJsonOutput #结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_Mem"
	
	LOG 0 "开始IAM环境巡检项：Check_IAM_Cpu_Usage"
	StartCheckItemJsonOutput "${CHECK_ENV_ITEM_CPU}" #开始检查项JSON输出
	Check_IAM_Cpu_Usage	#IAM的cpu使用率检测
    IAMUpdateProgress
	EndCheckItemJsonOutput #结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_Cpu_Usage"
	
	LOG 0 "开始IAM环境巡检项：Check_IAM_SSD"
	StartCheckItemJsonOutput "${CHECK_ENV_ITEM_SSD}" #开始检查项JSON输出
	Check_IAM_SSD	#IAM的SSD检测
    IAMUpdateProgress
	EndCheckItemJsonOutput #结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_SSD"
	
	LOG 0 "开始IAM环境巡检项：CheckPortBuffers"
	StartCheckItemJsonOutput "${CHECK_ENV_ITEM_PORTBLOCK}" #开始检查项JSON输出
	CheckPortBuffers	#IAM的端口阻塞检测
    IAMUpdateProgress
	EndCheckItemJsonOutput #结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：CheckPortBuffers"
	
	LOG 0 "开始IAM环境巡检项：CheckIamPgPressure"
	StartCheckItemJsonOutput "${CHECK_ENV_ITEM_PG}" #开始检查项JSON输出
	CheckIamPgPressure			#PG数据活跃连接数检查（活跃会话是指当前正在执行查询或操作的会话。这些会话可能正在读取数据、写入数据、执行事务等。）
    IAMUpdateProgress
	EndCheckItemJsonOutput 		#结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：CheckIamPgPressure"
	
	#dmesg日志检查
	LOG 0 "开始IAM环境巡检项：Check_IAM_Dmesg"
	StartCheckItemJsonOutput "${CHECK_DMESG_LOG}" #开始检查项JSON输出
	Check_IAM_Dmesg
    IAMUpdateProgress
	EndCheckItemJsonOutput 		#结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_Dmesg"
	
	#日志等级巡检
	LOG 0 "开始IAM环境巡检项：Check_IAM_Log_Level"
	StartCheckItemJsonOutput "${CHECK_LOG_LEVEL}" #开始检查项JSON输出
	Check_IAM_Log_Level
    IAMUpdateProgress
	EndCheckItemJsonOutput 		#结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_Log_Level"
	
	#磁盘IO检查
	LOG 0 "开始IAM环境巡检项：Check_IAM_IO"
	StartCheckItemJsonOutput "${CHECK_DISK_IO}" #开始检查项JSON输出
	Check_IAM_IO
    IAMUpdateProgress
	EndCheckItemJsonOutput 		#结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_IO"
	
	#替换库检查
	LOG 0 "开始IAM环境巡检项：Check_IAM_File_Time"
	StartCheckItemJsonOutput "${CHECK_REPLACE_LIB}" #开始检查项JSON输出
	Check_IAM_File_Time
    IAMUpdateProgress
	EndCheckItemJsonOutput 		#结束检查项JSON输出
	LOG 0 "结束IAM环境巡检项：Check_IAM_File_Time"
	
	
	# 结束全局检查项
	EndIpJsonOutput
	
	local str_engine_ssh_info=` sqlite3 ${CHECK_DB_FILE} "select * from ia_engine;" ` 
	
    IFS=$'\n' read -d '' -ra arr_engine_ssh_info <<< "$str_engine_ssh_info"
    
	#初始化KUNLUN2的板卡登录信息
	LOG 0 "加载昆仑2的板卡登录信息"
	Get_Chip_Ip "${arr_engine_ssh_info[@]}"
	# 判断数组是否为空
	if [ ${#BOARD_CHIP_IP[@]} -eq 0 ]; then
		LOG 0 "加载昆仑2的板卡登录信息为空"
	else
		LOG 0 "加载昆仑2的板卡登录信息数量: ${#BOARD_CHIP_IP[@]}"
	fi
	LOG 0 "加载昆仑2的板卡登录信息完成"
	
    local current_index=0
    local check_board_num=${#arr_engine_ssh_info[@]}
	# 巡检IAE信息
	for engien_ssh_info_line in "${arr_engine_ssh_info[@]}"
	do
        current_index=$(expr $current_index + 1)
        
		local ssh_ip=$(echo ${engien_ssh_info_line} | awk -F "|" '{print $1}')
		local ssh_port=$(echo ${engien_ssh_info_line} | awk -F "|" '{print $2}')
		local ssh_user_name=$(echo ${engien_ssh_info_line} | awk -F "|" '{print $3}')
		local ssh_passwd=$(echo ${engien_ssh_info_line} | awk -F "|" '{print $4}')
        local engine_name=$(Get_Engine_Name "${ssh_ip}")
        ProgressInit "${engine_name}" ${check_board_num} ${current_index} "${ssh_ip}"
        
		#IAE的巡检项JSON的IP头
		StartIpJsonOutput "${ssh_ip}"
		
		# BW服务状态检查
		LOG 0 "开始BW【${ssh_ip}】服务状态检查"
		StartCheckItemJsonOutput "${CHECK_BW_SERVER_STATUS}" #开始检查项JSON输出
		BwServerStatusCheck "${ssh_ip}" "${ssh_port}" "${ssh_user_name}" "${ssh_passwd}" 
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成BW【${ssh_ip}】服务状态检查"
		
		# IAE服务状态检查
		LOG 0 "开始IAE【${ssh_ip}】服务状态检查"
		StartCheckItemJsonOutput "${CHECK_IAE_SERVER_STATUS}" #开始检查项JSON输出
        IaeServerStatusCheck "${ssh_ip}" "${ssh_port}" "${ssh_user_name}" "${ssh_passwd}"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】服务状态检查"
		
		StartCheckItemJsonOutput "${CHECK_IAE_VERSION}" #开始检查项JSON输出
		# BW版本检查
		LOG 0 "开始BW【${ssh_ip}】版本检查"
		local bw_version=$(GetBwVersion "${ssh_ip}" "${ssh_port}" "${ssh_user_name}" "${ssh_passwd}")
        if [ -z "${bw_version}" ]
        then
            ResultTxtOutput "WARNING" "【${ssh_ip}】BW版本/补丁查询失败"
        else
            if [ "${iam_version}" == "${bw_version}" ]
            then
                ResultTxtOutput "INFO" "【${ssh_ip}】BW版本/补丁与IAM版本/补丁一致。版本号：${iam_version}"
            else
                ResultTxtOutput "ERROR" "【${ssh_ip}】BW版本/补丁与IAM版本/补丁不一致。IAM版本号：${iam_version}；BW版本号：${bw_version}"
            fi
        fi
        IAEUpdateProgress
		LOG 0 "完成BW版本检查"
		
		# IAE版本检查
		LOG 0 "开始IAE【${ssh_ip}】版本检查"
		local iae_version=$(GetIaeVersion "${ssh_ip}" "${ssh_port}" "${ssh_user_name}" "${ssh_passwd}")
        if [ -z "${iae_version}" ]
        then
            ResultTxtOutput "WARNING" "【${ssh_ip}】IAE版本/补丁查询失败"
        else
            if [ "${iam_version}" == "${iae_version}" ]
            then
                ResultTxtOutput "INFO" "【${ssh_ip}】IAE版本/补丁与IAM版本/补丁一致。版本号：${iam_version}"
            else
                ResultTxtOutput "ERROR" "【${ssh_ip}】IAE版本/补丁与IAM版本/补丁不一致。IAM版本号：${iam_version}；IAE版本号：${bw_version}"
            fi
        fi
        IAEUpdateProgress
		LOG 0 "结束IAE【${ssh_ip}】版本检查"
		EndCheckItemJsonOutput #结束检查项JSON输出
		
		# 其他检查请在此添加
        # 芯片免密登录检查
        LOG 0 "开始IAE【${ssh_ip}】芯片免密登录检查"
        if [ "$engine_name" != "GPU" ];then
            StartCheckItemJsonOutput "${CHECK_CHIP_PASSWORD_FREE}" #开始检查项JSON输出
            PasswordFreeCheck "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
            IAEUpdateProgress
            EndCheckItemJsonOutput #结束检查项JSON输出
            LOG 0 "结束IAE【${ssh_ip}】芯片免密登录检查"
        else 
            LOG 0 "gPU板卡不进行芯片免密登录"
        fi
        
		# core检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_Coredump"
		StartCheckItemJsonOutput "${CHECK_ENV_ITEM_CORE}" #开始检查项JSON输出
		Check_BW_Coredump "$ssh_ip" "$ssh_port" "$ssh_user_name" "$ssh_passwd"
		Check_IAE_Coredump "$ssh_ip" "$ssh_port" "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：Check_IAE_Coredump"
		
		# 僵尸进程检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_Zombie_Processes"
		StartCheckItemJsonOutput "${CHECK_ENV_ITEM_ZOMBIE}" #开始检查项JSON输出
		Check_IAE_Zombie_Processes "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_BW_Zombie_Processes "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：Check_IAE_Zombie_Processes"
		
		# 端口监听检查
		if [ "$engine_name" != "GPU" ];then
			LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_NetTable"
			StartCheckItemJsonOutput "${CHECK_ENV_ITEM_PORTLISTEN}" #开始检查项JSON输出
			Check_IAE_NetTable "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
			IAEUpdateProgress
			EndCheckItemJsonOutput #结束检查项JSON输出
			LOG 0 "完成IAE【${ssh_ip}】环境巡检项：Check_IAE_NetTable"
		else
			LOG 1 "GPU板卡不进行板卡监听检查巡检"
		fi
		
		# 磁盘检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_Disk"
		StartCheckItemJsonOutput "${CHECK_ENV_ITEM_DISK}" #开始检查项JSON输出
		Check_IAE_Disk "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_BW_Disk "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：Check_IAE_Disk"
		
		# 内存检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_Mem"
		StartCheckItemJsonOutput "${CHECK_ENV_ITEM_MEMORY}" #开始检查项JSON输出
		Check_IAE_Mem "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_BW_mem "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：Check_IAE_Mem"
		
		# CPU检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_Cpu_Usage"
		StartCheckItemJsonOutput "${CHECK_ENV_ITEM_CPU}" #开始检查项JSON输出
		Check_IAE_Cpu_Usage "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_BW_Cpu_Usage "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：Check_IAE_Cpu_Usage"
		
		# SSD检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_SSD"
		StartCheckItemJsonOutput "${CHECK_ENV_ITEM_SSD}" #开始检查项JSON输出
		Check_IAE_SSD "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：Check_IAE_SSD"
		
		# DMESG日志检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：DMESG日志检查"
		StartCheckItemJsonOutput "${CHECK_DMESG_LOG}" #开始检查项JSON输出
		Check_BW_Dmesg "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_IAE_Dmesg "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：DMESG日志检查"
		
		# 磁盘IO检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：磁盘IO检查"
		StartCheckItemJsonOutput "${CHECK_DISK_IO}" #开始检查项JSON输出
		Check_BW_IO "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_IAE_IO "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：磁盘IO检查"
		
		# debug日志开启检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：debug日志开启检查"
		StartCheckItemJsonOutput "${CHECK_LOG_LEVEL}" #开始检查项JSON输出
		Check_BW_Log_Level "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_IAE_Log_Level "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：debug日志开启检查"
		
		# 替换库检查
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：替换库检查"
		StartCheckItemJsonOutput "${CHECK_REPLACE_LIB}" #开始检查项JSON输出
		Check_BW_File_Time "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_IAE_File_Time "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：替换库检查"
		
		# 时间同步检测
		LOG 0 "开始IAE【${ssh_ip}】环境巡检项：时间同步检测"
		StartCheckItemJsonOutput "${CHECK_SYNC_TIME}" #开始检查项JSON输出
		Check_BW_Time "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
		Check_IAE_Time "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
        IAEUpdateProgress
		EndCheckItemJsonOutput #结束检查项JSON输出
		LOG 0 "完成IAE【${ssh_ip}】环境巡检项：Check_IAE_Dmesg"
		
		
		# 板卡端口映射
		# GPU不做主控映射检查
		if [ "$engine_name" != "GPU" ];then
			LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_BoardNetTable"
			StartCheckItemJsonOutput "${CHECK_ENV_ITEM_NETPORT}" #开始检查项JSON输出
			Check_IAE_BoardNetTable "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
            IAEUpdateProgress
			EndCheckItemJsonOutput #结束检查项JSON输出
			LOG 0 "开始IAE【${ssh_ip}】环境巡检项：Check_IAE_BoardNetTable"
		else
			LOG 1 "GPU板卡不进行板卡端口映射巡检"
		fi
		
		# 特定的板卡检查
		if [ "$engine_name" == "GPU" ];then
			LOG 0 "开始GPU【${ssh_ip}】环境巡检项：CheckGpuState"
			CheckGpuEnvironment "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
			LOG 0 "结束GPU【${ssh_ip}】环境巡检项：CheckGpuState"
		elif [ "${engine_name}" == "AX" ];then
			LOG 0 "开始爱芯【${ssh_ip}】环境巡检项：CheckAxStatus"
			CheckAxEnvironment "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
			LOG 0 "完成爱芯【${ssh_ip}】环境巡检项：CheckAxStatus"
		elif [ "${engine_name}" == "寒武纪" ];then
			LOG 0 "开始寒武纪【${ssh_ip}】环境巡检项：CheckMluStatus"
			CheckMluEnvironment "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd" 
			LOG 0 "结束寒武纪【${ssh_ip}】环境巡检项：CheckMluStatus"
		elif [ "${engine_name}" == "昆仑3" ];then
			LOG 0 "开始昆仑3【${ssh_ip}】环境巡检项：CheckHisiDriver"
			CheckHisiEnvironment "$ssh_ip" "$ssh_port"  "$ssh_user_name" "$ssh_passwd"
			LOG 0 "结束昆仑3【${ssh_ip}】环境巡检项：CheckHisiDriver"
		fi
		EndIpJsonOutput
	done
}

# 初始化相关操作
LOG 0 "开始初始化日志目录"
FileInit
LOG 0 "初始化日志目录完成"
	
LOG 0 "开始校验巡检数据库文件"
LoadCheckDbFile
LOG 0 "校验巡检数据库文件完成"
	
LOG 0 "开始加载板卡登录信息"
LoadIaeIpAndPasswd
LOG 0 "加载板卡登录信息完成"
# 开始JSON
StartJsonOutput
IACheckMain
MqBalanceBusincessCheck
# 结束Json输出
EndJsonOutput

# 生成巡检报告
cmd=` /${UTIL_FOR_REPORT} ${CHECK_RESULT_JSON_FILE} ${CHECK_RESULT_EXCEL_FILE} `

# 控制台打印
python ${OUTPUT_TO_CONSOLE_FILE}