#!/bin/bash

### 安装全局命令
InstallGlobalCommand()
{
    echo "开始安装全局命令"
    if [ -f "/usr/local/sbin/IACheck.sh" ];
	then
        echo "[OK]全局命令已经安装，无需重复安装"
		return 
    fi	 
	cp "${CURRENT_DIR}/IACheck.sh" "${DATA_PATH}/bin/"
	cp "${CURRENT_DIR}/IACheckUninstall.sh" "${DATA_PATH}/bin/"
	cmd=` ln -s ${DATA_PATH}/bin/IACheck.sh /usr/local/sbin/IACheck.sh `
	cmd=` ln -s ${DATA_PATH}/bin/IACheckUninstall.sh /usr/local/sbin/IACheckUninstall.sh `
	cmd=` ln -s ${DATA_PATH}/bin/LogCollect.sh /usr/local/sbin/LogCollect.sh `
	echo "[OK]全局命令安装完成"
}

### 文件拷贝到运行bin目录
FileCopyToDataPath()
{
    cp -r "${CURRENT_DIR}/bus_check" "${DATA_PATH}/bin/"
    cp -r "${CURRENT_DIR}/common_def" "${DATA_PATH}/bin/"
    cp -r "${CURRENT_DIR}/env_check" "${DATA_PATH}/bin/"
    cp -r "${CURRENT_DIR}/python" "${DATA_PATH}/bin/"
    cp -r "${CURRENT_DIR}/third_party" "${DATA_PATH}/bin/"
	cp -r "${CURRENT_DIR}/collect_log" "${DATA_PATH}/bin/"
    cp "${CURRENT_DIR}/IACheckInstall.sh" "${DATA_PATH}/bin/"
    cp "${CURRENT_DIR}/IACheck.sh" "${DATA_PATH}/bin/"
    cp "${CURRENT_DIR}/IACheckUninstall.sh" "${DATA_PATH}/bin/"
	cp "${CURRENT_DIR}/LogCollect.sh" "${DATA_PATH}/bin/"
    # 赋可执行权限
    cmd=` find "${DATA_PATH}/bin" -type f -exec chmod +x {} \; `
}

### 安装脚本主函数
MainInstall()
{
    ### 判断是否已经安装脚本，已经安装的情况下，先执行卸载脚本
    if [ -f "/usr/local/sbin/IACheck.sh" ];
	then
        echo -e "当前环境中存在旧版本的巡检脚本，是否卸载旧版脚本，安装新版脚本。允许重新安装请输入y，禁止重新安装请输入n"
        while :
        do
            read userInstallChonse
            if [ "${userInstallChonse}" != "y" ]
            then
                if [ "${userInstallChonse}" != "n" ]
                then
                    echo -e "输入错误，请重新输入y或者n"
                    continue;
                fi
                echo "用户取消了安装"
                exit 1
                
            else
                IACheckUninstall.sh
                break;
            fi
        done
    fi	 
    
    
    ### 初始化操作
	FileInit
	FileCopyToDataPath
    InstallGlobalCommand
	echo "[OK]安装完成"
}

declare CURRENT_DIR=$(dirname $(readlink -f "$0"))	#shell脚本当前目录
source ${CURRENT_DIR}/common_def/GlobalVariable.sh
source ${CURRENT_DIR}/common_def/IACheckUtils.sh

### 运行安装脚本主函数
MainInstall