#!/bin/bash

KUNLUN2_VAS_CHIP_NUM=0
OTH_VAS_CHIP_NUM=0
ALLSTRUCT_CHIP_NUM=0 
FACE_CHIP_NUM=0
ALL_VAS_CHEIP_NUM=0
ALLSTRUCT_SINGLEON_CHIP_NUM=0

### 获取芯片数量
GetChipNum()
{
    KUNLUN2_VAS_CHIP_NUM=` SelectDB "sqlite" "SELECT COUNT(*) FROM ia_engine WHERE business_type=103 AND engine_version=1;" `
    ALL_VAS_CHEIP_NUM=` SelectDB "sqlite" "SELECT COUNT(*) FROM ia_engine WHERE business_type=103;" `
    ALLSTRUCT_SINGLEON_CHIP_NUM=` SelectDB "sqlite" "SELECT COUNT(*) FROM ia_engine WHERE business_type=903;" ` #全结构化二次解析
    OTH_VAS_CHIP_NUM=$(expr $ALL_VAS_CHEIP_NUM - $KUNLUN2_VAS_CHIP_NUM + $ALLSTRUCT_SINGLEON_CHIP_NUM)
    ALLSTRUCT_CHIP_NUM=` SelectDB "sqlite" "SELECT COUNT(*) FROM ia_engine WHERE business_type=902;" ` #全结构化全量解析
    FACE_CHIP_NUM=` SelectDB "sqlite" "SELECT COUNT(*) FROM ia_engine WHERE business_type BETWEEN 300 AND 304;" `
}

### MQ负载均衡业务检查
MqBalanceBusincessCheck()
{
    # MQ json输出开始
    StartIpJsonOutput "MQ"
    # MQ巡检进度初始化
    ProgressInit "MQ"
    
    # 数据积压检查
    StartCheckItemJsonOutput "${CHECK_MQ_DATA_DELAY}" #开始检查项JSON输出
    mq_data_delay_check_result=` python ${MQ_DATA_DELAY_CHECK_FILE} ` # 调用python脚本进行巡检
    FormatPyhtonCheckReuslt $? "${mq_data_delay_check_result}" # 记录python脚本检查结果
    MQUpdateProgress # 巡检项进度更新
    EndCheckItemJsonOutput #结束检查项JSON输出
    
    #队列数检查
    GetChipNum
    StartCheckItemJsonOutput "${CHECK_MQ_QEUE}" #开始检查项JSON输出
    mq_qeue_check_result=` python ${MQ_QEUE_CHECK_FILE} ${KUNLUN2_VAS_CHIP_NUM} ${OTH_VAS_CHIP_NUM} ${ALLSTRUCT_CHIP_NUM} ${FACE_CHIP_NUM} ` # 调用python脚本进行巡检
    FormatPyhtonCheckReuslt $? "${mq_qeue_check_result}" # 记录python脚本检查结果
    MQUpdateProgress # 巡检项进度更新
    EndCheckItemJsonOutput #结束检查项JSON输出
    
	#mq的banlance数据格式检查
	StartCheckItemJsonOutput "${CHECK_MQ_BALANCE_DATA_FORMAT}" #开始检查项JSON输出
    mq_balance_data_format_check_result=` python ${MQ_BALANCE_DATA_FORMAT_CHECK_FILE} ` # 调用python脚本进行巡检
    FormatPyhtonCheckReuslt $? "${mq_balance_data_format_check_result}" # 记录python脚本检查结果
    MQUpdateProgress # 巡检项进度更新
    EndCheckItemJsonOutput #结束检查项JSON输出
	
    #数据更新检查
    StartCheckItemJsonOutput "${CHECK_MQ_DATA_UPDATA}" #开始检查项JSON输出
    mq_data_update_result=` python ${MQ_DATA_UPDATE_FILE} ` # 调用python脚本进行巡检
    FormatPyhtonCheckReuslt $? "${mq_data_update_result}" # 记录python脚本检查结果
    MQUpdateProgress # 巡检项进度更新
    EndCheckItemJsonOutput #结束检查项JSON输出
    
    #MQ接入数据量统计
	StartCheckItemJsonOutput "${CHECK_MQ_DATA_COUNT_STATISTICS}" #开始检查项JSON输出
    mq_data_update_result=` python ${MQ_DATA_COUNT_STATISTICS} "${IAM_PG_PASSWD}" ` # 调用python脚本进行巡检
    FormatPyhtonCheckReuslt $? "${mq_data_update_result}" # 记录python脚本检查结果
    MQUpdateProgress # 巡检项进度更新
    EndCheckItemJsonOutput #结束检查项JSON输出
    
	#mq数据丢失检查
	StartCheckItemJsonOutput "${CHECK_MQ_DATA_LOSS}" #开始检查项JSON输出
	#入参
	dbname="ias"
	user="postgres"
	password="${IAM_PG_PASSWD}"
	host="127.0.0.1"
	port=${IAM_PG_PORT}
    mq_data_update_result=` python ${MQ_DATA_LOSS_CHECK_FILE} ${dbname} ${user} ${password} ${host} ${port} ${FACE_CHIP_NUM} ${ALL_VAS_CHEIP_NUM} ${ALLSTRUCT_SINGLEON_CHIP_NUM} ${ALLSTRUCT_CHIP_NUM} ` # 调用python脚本进行巡检
    FormatPyhtonCheckReuslt $? "${mq_data_update_result}" # 记录python脚本检查结果
    MQUpdateProgress # 巡检项进度更新
    EndCheckItemJsonOutput #结束检查项JSON输出
	
    
    # MQ json输出结束
    EndIpJsonOutput
}