#!/bin/bash

#加载JSON文档输出
source ${DATA_PATH}/bin/common_def/JsonHander.sh

### 记录文本格式的巡检结果，供运维及智能研发使用。
###   $1 检查结果状态（INFO, WARNING, ERROR）
###   $2 检查结果
ResultTxtOutput()
{
	#txt巡检结果输出
    local status="$1"
    local message="$2"
	LOG 1 "【${status}】${message}"
	#JSON巡检报告输出
	if [ "${status}" == "INFO" ];then
		AppendMessageAndStatus "${STATUS_NORMAL}" "${message}"
	elif [ "${status}" == "WARNING" ];then
		AppendMessageAndStatus "${STATUS_EXCEPTION}" "${message}"
	else
		AppendMessageAndStatus "${STATUS_ERROR}" "${message}"
	fi
}

### shell脚本命令执行结果收集
### $1 执行命令的服务器IP
### $2 执行的命令
### $3 命令执行结果
RecordCommndInfo()
{
    local current_time=` date "+%Y-%m-%d %H:%M:%S" `
    echo "******************************************************" >> "${CHECK_INFO_FILE}"
	echo  "${current_time} 【$1】 【$2】" >> "${CHECK_INFO_FILE}"
    echo -e "$3" >> "${CHECK_INFO_FILE}"
    echo "******************************************************" >> "${CHECK_INFO_FILE}"
}

### 日志记录
### $1 否需要打印到控制台（0：需要输出到控制台，1：不需要输出到控制台)
### $2 需要输出的日志
LOG()
{
	local current_time=` date "+%Y-%m-%d %H:%M:%S" `
    # if [ $1 -eq 0 ]
	# then
	    # echo "${current_time}  $2"
	# fi
	echo -e "${current_time}  $2" >> "${CHECK_LOG_FILE}"
}