#!/bin/bash

TOTAL_CHECK_NUM=0
total_board_num=0
current_board_index=0
current_board_ip=""
current_check_progress=0
### 进度相关数据初始化
### $1 当前板卡类型
### $1 当前环境板卡总数
### $2 当前巡检第几张板卡
### $3 当前板卡IP
ProgressInit()
{
    if [ "$1" == "GPU" ]
    then
        # GPU支持巡检项： 
        # 1、BW服务状态；2、IAE服务状态；3、BW版本检查；4、IAE版本检查；5、core检查；6、僵尸经常检查；7、磁盘检查；8、内存检查；9、CPU检查；
        # 10、SSD检查；11、物理卡在线状态检查；12、温度检查；13、dmesg日志巡检；14、磁盘IO巡检; 15、DEBUG日志巡检; 16、替换库巡检; 17、时间同步巡检; 
        TOTAL_CHECK_NUM=17
    elif [ "$1" == "AX" ]
    then
        # 爱芯支持巡检项：
        # BW服务状态；2、IAE服务状态；3、BW版本检查；4、IAE版本检查；5、core检查；6、僵尸经常检查；7、端口监听检查；8、磁盘检查；9、内存检查；
        # 10、CPU检查；11、SSD检查；12、端口映射检查；13、驱动版本检查；14、温度检查；15、芯片驱动运行状态检查，16、芯片NG检查；17、dmesg日志巡检
		# 18、磁盘IO巡检; 19、DEBUG日志巡检; 20、替换库巡检; 21、时间同步巡检; 22、芯片免密登录检查；
        TOTAL_CHECK_NUM=22
    elif [ "$1" == "寒武纪" ]
    then
        # 寒武纪支持巡检项：
        # BW服务状态；2、IAE服务状态；3、BW版本检查；4、IAE版本检查；5、core检查；6、僵尸经常检查；7、端口监听检查；8、磁盘检查；9、内存检查；
        # 10、CPU检查；11、SSD检查；12、端口映射检查；13、驱动版本检查；14、温度检查；15、芯片驱动运行状态检查，16、芯片NG检查；17、dmesg日志巡检
		# 18、磁盘IO巡检; 19、DEBUG日志巡检; 20、替换库巡检; 21、时间同步巡检; 22、芯片免密登录检查； 
        TOTAL_CHECK_NUM=22
    elif [ "$1" == "昆仑3" ]
    then
        # 昆仑3巡检项：
        # BW服务状态；2、IAE服务状态；3、BW版本检查；4、IAE版本检查；5、core检查；6、僵尸经常检查；7、端口监听检查；8、磁盘检查；9、内存检查；
        # 10、CPU检查；11、SSD检查；12、端口映射检查；13、驱动版本检查；14、dmesg日志巡检；15、磁盘IO巡检; 16、DEBUG日志巡检; 17、替换库巡检; 
        # 18、时间同步巡检; 19、芯片免密登录检查； 
        TOTAL_CHECK_NUM=19
    elif [ "$1" == "昆仑2" ]
    then
        # 昆仑2巡检项：
        # BW服务状态；2、IAE服务状态；3、BW版本检查；4、IAE版本检查；5、core检查；6、僵尸经常检查；7、端口监听检查；8、磁盘检查；9、内存检查；
        # 10、CPU检查；11、SSD检查；12、端口映射检查；13、dmesg日志巡检；14、磁盘IO巡检; 15、DEBUG日志巡检; 16、替换库巡检; 17、时间同步巡检; 
        # 18、芯片免密登录检查；
        TOTAL_CHECK_NUM=18
    elif [ "$1" == "IAM" ]
    then
        # iam巡检项：
        # 1、iam服务运行状态；2、iam崩溃检查；3、vm数据库密码检查；4、存储组网检查；5、DBE ip配置检查；6、MD相关配置检查；7、布控组网检查；
        # 8、人脸静态导库组网检查；9、IAM的core检查；10、僵尸进程检查；11、磁盘空间检查；12、内存检测；13、cpu使用率检测；14、SSD检测；
        # 15、端口阻塞检测； 16、PG数据活跃连接数检查；17、最低软件版本检查；18、分析模式校验；19、dmesg日志巡检；20、磁盘IO巡检; 21、DEBUG日志巡检;
		# 22、替换库巡检; 23、IAM pg数据库密码配置检查；24、芯片运行状态检查；25、防火墙状态检查；26、人脸图片流负载均衡状态检查；27、芯片资源分配检查；
		# 28、授权检查；29、资源分配和授权是否匹配检查；30、授权时间检查；31、任务路数和资源分配匹配巡检；32、行为分析告警阈值检查
        TOTAL_CHECK_NUM=32
    elif [ "$1" == "MQ" ]
    then
        # MQ负载均衡业务巡检项：
        # 1、数据积压检查；2、队列数检查；3、数据更新检查；4、MQ接入数据量统计；5、balance数据格式校验 6、MD数据丢失情况
        TOTAL_CHECK_NUM=6
    fi
    total_board_num=$2
    current_board_index=$3
    current_board_ip="$4"
    current_check_progress=0
}

### IAM巡检进度记录
IAMUpdateProgress()
{
     current_check_progress=$(expr $current_check_progress + 1)
     printf "\r正在巡检IAM, 当前IAM巡检进展%d/%d" "${current_check_progress}" "${TOTAL_CHECK_NUM}"
     if [ ${current_check_progress} -ge ${TOTAL_CHECK_NUM} ]
     then
         printf "\n"
     fi
}

### IAE巡检进度记录
IAEUpdateProgress()
{
    current_check_progress=$(expr $current_check_progress + 1)
    printf "\r正在巡检第%d/%d块板卡，当前巡检板卡IP：%s，当前板卡巡检进展%d/%d" "${current_board_index}" "${total_board_num}"  "${current_board_ip}" "${current_check_progress}" "${TOTAL_CHECK_NUM}"
    if [ ${current_check_progress} -ge ${TOTAL_CHECK_NUM} ]
    then
        printf "\n"
    fi
}

### MQ负载均衡检查进度记录
MQUpdateProgress()
{
    current_check_progress=$(expr $current_check_progress + 1)
    printf "\r正在巡检MQ负载均衡信息, 当前MQ负载均衡信息巡检进展%d/%d" "${current_check_progress}" "${TOTAL_CHECK_NUM}"
    if [ ${current_check_progress} -ge ${TOTAL_CHECK_NUM} ]
    then
        printf "\n"
    fi
}

