﻿# coding=utf-8
#校验资源分配但是无授权的情况
import subprocess
import sys
import common
import time
import platform
import urllib2
import urllib

# 获取授权相关的接口
#老版本相关接口
# k2:人脸识别业务、视频结构化业务、行为分析通用业务  昆仑2只有板卡授权即可 不进行校验，授权时间巡检项已经对k2板卡是否授权进行校验
# K3:人脸识别业务【IaBusinessFA_V3】、视频结构化业务【IaBusinessVAS_V3】、行为分析通用业务【IaBusinessBA_V3】、行为分析地铁业务【IaBusinessBAS_V3】、交通违法业务【IaBusinessCEP_V3】、交通事件业务【IaBusinessTA_V3】
# GPU：人脸识别业务80路【10047】/400路(图)【10046】、视频结构化业务80路【10048】/1000万张【10049】、行为分析通用业务60路(GPU)【10043】、行为分析地铁业务60路(GPU)【20019】
# MLU：人脸图片【5000000】、人脸视频【5000001】、视频结构化【5000003】、图片结构化【5000002】、监管行为分析【20023】、综合行为分析【20025】
global_authorize_info = {}   #缓存老版本的授权信息，只有业务授权的路数，没有使用量，key对应的业务编码（IaBusinessFA_V3、5000000等）
#获取kunlun3的授权信息
def getAuthorizeInfo():
    global global_authorize_info
    # 获取IAM的授权到期情况
    int_time = int(time.time() * 1000)
    # URL
    url = "http://127.0.0.1:8084/iam3/licensemanage/getAuthorizeInfo"
    # 参数
    params = {"t": int_time,"condition":2}
    # 构建查询字符串
    query_string = urllib.urlencode(params)
    # 完整的URL
    full_url = url + '?' + query_string
    # 获取请求数据
    json_result = common.GetDataFromUrl(full_url)
    # 打印日志信息
    info_message = "HTTP请求【%s】返回的数据信息【%s】" % (full_url, json_result)
    common.Log(info_message)
    # 解析返回的结果
    json_object = common.ParseJsonData(json_result)
    #增加判断，如果不是json格式则提示
    if json_result != ""  and json_object == "":
        #返回的数据不是json格式
        info_message = "HTTP请求【%s】返回的数据信息不是json格式，不支持该接口" % (full_url)
        common.Log(info_message)
        return False
    # 检查 'AuthorizeInfo' 是否存在且不为空
    if 'AuthorizeInfo' in json_object and len(json_object['AuthorizeInfo']) > 0:
        for key, value in json_object["AuthorizeInfo"].items():
            global_authorize_info[key] = value
    else:
        str_total_messgae = "获取授权情况为空，巡检IAM授权使用信息异常退出"
        common.Log(str_total_messgae)
    # 返回数据
    return True

#获取GPU的授权信息
def getAuthorizeDetailInfoGPU():
    global global_authorize_info
    # 获取IAM的授权到期情况
    int_time = int(time.time() * 1000)
    # URL
    url = "http://127.0.0.1:8084/iam3/licensemanage/getAuthorizeDetailInfo"
    # 参数
    params = {"t": int_time,"condition":3}
    # 构建查询字符串
    query_string = urllib.urlencode(params)
    # 完整的URL
    full_url = url + '?' + query_string
    # 获取请求数据
    json_result = common.GetDataFromUrl(full_url)
    # 打印日志信息
    info_message = "HTTP请求【%s】返回的数据信息【%s】" % (full_url, json_result)
    common.Log(info_message)
    # 解析返回的结果
    json_object = common.ParseJsonData(json_result)
    #增加判断，如果不是json格式则提示
    if json_result != ""  and json_object == "":
        #返回的数据不是json格式
        info_message = "HTTP请求【%s】返回的数据信息不是json格式，不支持该接口" % (full_url)
        common.Log(info_message)
        return False
    # 检查 'AuthorizeDetailInfo' 是否存在且不为空
    if 'AuthorizeDetailInfo' in json_object and len(json_object['AuthorizeDetailInfo']) > 0:
        for key, value in json_object["AuthorizeDetailInfo"].items():
            global_authorize_info[key] = value
    else:
        str_total_messgae = "获取授权情况为空，巡检IAM授权使用信息异常退出"
        common.Log(str_total_messgae)
    # 返回数据
    return True

#获取mlu的授权信息
def getAuthorizeDetailInfoMLU():
    global global_authorize_info
    # 获取IAM的授权到期情况
    int_time = int(time.time() * 1000)
    # URL
    url = "http://127.0.0.1:8084/iam3/licensemanage/getAuthorizeDetailInfo"
    # 参数
    params = {"t": int_time,"condition":4}
    # 构建查询字符串
    query_string = urllib.urlencode(params)
    # 完整的URL
    full_url = url + '?' + query_string
    # 获取请求数据
    json_result = common.GetDataFromUrl(full_url)
    # 打印日志信息
    info_message = "HTTP请求【%s】返回的数据信息【%s】" % (full_url, json_result)
    common.Log(info_message)
    # 解析返回的结果
    json_object = common.ParseJsonData(json_result)
    #增加判断，如果不是json格式则提示
    if json_result != ""  and json_object == "":
        #返回的数据不是json格式
        info_message = "HTTP请求【%s】返回的数据信息不是json格式，不支持该接口" % (full_url)
        common.Log(info_message)
        return False
    # 检查 'AuthorizeDetailInfo' 是否存在且不为空
    if 'AuthorizeDetailInfo' in json_object and len(json_object['AuthorizeDetailInfo']) > 0:
        for key, value in json_object["AuthorizeDetailInfo"].items():
            global_authorize_info[key] = value
    else:
        str_total_messgae = "获取授权情况为空，巡检IAM授权使用信息异常退出"
        common.Log(str_total_messgae)
    # 返回数据
    return True

#新版本授权获取接口
# 58P02到58P05版本的授权格式：
# k2:人脸识别业务、视频结构化业务、行为分析通用业务  昆仑2只有板卡授权即可，不涉及k2的巡检
# K3:人脸业务单元授权【10038】、机非人业务单元授权【10039】、行为分析业务单元授权【10040】、地铁业务单元授权【20021】、交通违法业务单元授权【10044】、交通事件业务单元授权【10152】
# GPU：人脸视频流业务授权【10047】、人脸图片流业务授权【10046】、机非人视频流业务授权【10048】、机非人图片流业务授权【10049】、行为分析业务授权【10043】、地铁行为分析业务授权【20019】
# MLU：全结构化授权【20022】  （行为分析实际不进行强校验，都是行为分析的授权加和）监管行为分析【20023】、综合行为分析【20025】
# 58P05版本之后使用的下面的授权格式：
# K3:交通违法业务【10044】
# 智能通用授权：交通事件分析授权【20029】、通用行为分析业务授权【20025】、通用全结构化授权【20022】

global_licenseUsedInfo = {}  #缓存新版本授权信息,包括总授权和使用授权
#新版本接口
def getLicenseUsedInfo():
    global global_licenseUsedInfo
    # 获取IAM的授权到期情况
    int_time = int(time.time() * 1000)
    # URL
    url = "http://127.0.0.1:8084/iam3/licensemanage/getLicenseUsedInfo"
    # 参数
    params = {"t": int_time}
    # 构建查询字符串
    query_string = urllib.urlencode(params)
    # 完整的URL
    full_url = url + '?' + query_string
    # 获取请求数据
    json_result = common.GetDataFromUrl(full_url)
    if json_result == "":
        #返回的数据不是json格式
        info_message = "HTTP请求【%s】返回的数据信息为空，不支持该接口" % (full_url)
        common.Log(info_message)
        return False
    # 打印日志信息
    info_message = "HTTP请求【%s】返回的数据信息【%s】" % (full_url, json_result)
    common.Log(info_message)
    # 解析返回的结果
    json_object = common.ParseJsonData(json_result)
    #增加判断，如果不是json格式则提示
    if json_result != ""  and json_object == "":
        #返回的数据不是json格式
        info_message = "HTTP请求【%s】返回的数据信息不是json格式，不支持该接口" % (full_url)
        common.Log(info_message)
        return False
    # 检查 'IAMInfo' 是否存在且不为空
    if 'Config' in json_object and len(json_object['Config']) > 0:
        for config in json_object["Config"]:
            iAuthCode = config["iAuthCode"]
            dlTotalNum = config["dlTotalNum"]
            dlUsedNum = config["dlUsedNum"]
            # 使用 iAuthCode 作为键，将其他信息存储在一个嵌套字典中
            global_licenseUsedInfo[iAuthCode] = {
                "dlTotalNum": dlTotalNum,
                "dlUsedNum": dlUsedNum
            }
    else:
        int_total_ret = common.EXIT_STATUS_WARNING
        str_total_messgae = "获取授权情况为空，巡检授权使用信息异常退出"
        common.Log(str_total_messgae)
    # 返回数据
    return True

#新版本授权信息总数量
def getAuthorTotalNum(iAuthCode):
    int_ret = 0
    if iAuthCode in global_licenseUsedInfo:
        value = global_licenseUsedInfo.get(iAuthCode)
        int_ret = value.get("dlTotalNum",0)
    return int_ret


#获取资源分配情况相关的接口
# 定义业务类型常量
BussinesType_Unknown_V3 = 0                    #未知
BussinesType_VAS_Video_V3 = 100           #结构化视频流
BussinesType_Vas_Pic_V3 = 103             #结构化图片流
BussinesType_FS_Video_V3 = 400            #人脸视频流
BussinesType_FS_Pic_V3 = 300              #人脸图片流
BussinesType_FS_FeatureRextract_V3 = 304  #人脸特征清洗
BussinesType_FS_PicSearch_V3 = 305        #人脸图搜
BussinesType_BA_Supervise_V3 = 200           #行为分析监管类型
BussinesType_BA_PersonAnalysis_V3 = 203     #行为分析人群分析
BussinesType_BA_Action_V3 = 202             #行为分析动作类型
BussinesType_BA_PersonNumStatic_V3 = 201    #行为分析人数统计
BussinesType_BA_Safety_V3 = 208            #行为分析安全
BussinesType_BA_CommonVideo_V5 = 210             #昆仑5、GPU、爱芯行为分析通用
BussinesType_AS_Video_V3 = 902              #全结构化视频流
BussinesType_AS_PicSingle_V3 = 903          #全结构化二次解析
BussinesType_AS_PicAll_V3 = 901             #全结构化全量解析

#定义tasktype枚举
TaskType_Unknown = 0 #未知类型
TaskType_vas = 1    #结构化业务
TaskType_fS = 2     #人脸业务
TaskType_ba = 3     #行为分析业务
TaskType_bas = 7    #地铁行为分析
TaskType_as = 9     #全结构化业务

#引擎类型
EngineType_k2 = 1 #昆仑2
EngineType_k3 = 2 #昆仑3
EngineType_gpu = 3 #GPU
EngineType_MLU = 4 #寒武纪
EngineType_aixin = 7 #爱芯

global_statics_data={}  #汇总资源使用情况，用枚举类型描述的结构体
def getSqllite3Data(str_sql):
    bool_ret=False
    str_ret=""
    #获取单行sql
    sql_query_single_line = str_sql.replace('\n', ' ').strip()
    #调用sql命令
    os_type = platform.system()
    if os_type == 'Windows':
        sqlite_command = 'sqlite3.exe {} "{}"'.format("ias.db", sql_query_single_line)
    elif os_type == 'Linux':
        sqlite_command = 'sqlite3 {} "{}"'.format("/opt/wise/ia12k/db/ias.db", sql_query_single_line)
    info_message = "组织的sql命令为：%s" % (sql_query_single_line)
    common.Log(info_message)
    #获取结果
    try:
        # 使用 subprocess.Popen 执行命令
        process = subprocess.Popen(sqlite_command, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True,universal_newlines=True)
        # 获取输出和错误信息
        stdout, stderr = process.communicate()
        if process.returncode != 0:
            info_message = "Error executing SQLite command: %s" % (common.GetUtf8Str(stderr))
            common.Log(info_message)
        else:
            # 解析输出
            bool_ret = True
            str_ret = stdout
    except Exception as e:
        info_message = "Error executing SQLite command，An error occurred: %s" % (common.GetUtf8Str(e))
        common.Log(info_message)
    return bool_ret,str_ret

def handelStaticData(engine_version, task_type, business_type, count):
    global global_statics_data
    # 如果该engine_version不存在，则初始化
    if int(engine_version) not in global_statics_data:
        global_statics_data[int(engine_version)] = {}
    # 如果task_type不存在，则初始化
    if int(task_type) not in global_statics_data[int(engine_version)]:
        global_statics_data[int(engine_version)][int(task_type)] = {}
    if int(business_type) not in global_statics_data[int(engine_version)][int(task_type)]:
        global_statics_data[int(engine_version)][int(task_type)][int(business_type)] = 0
    # 赋值
    global_statics_data[int(engine_version)][int(task_type)][int(business_type)] = int(count)

#处理数据
def handleSqlLiteData(str_lines):
    for line in str_lines:
        # 去除行首和行尾的空白字符
        line = line.strip()
        # 检查行是否为空
        if not line:
            continue
        # 尝试拆分行
        parts = line.split('|')
        # 确保拆分后的部分数量正确
        if len(parts) != 4:
            info_message = "获取的数据，按照|分割，不足4个字段长度: %s" % (line)
            common.Log(info_message)
            continue
        # 处理数据
        engine_version, task_type, business_type, count = parts
        try:
            #汇总统计数据，累加使用的
            handelStaticData(engine_version, task_type, business_type, count)
        except KeyError as e:
            print("KeyError: The key does not exist in the globals dictionary.{}".format(e))
        except IndexError as e:
            print("IndexError: The index is out of range of the global_task_type_value_enums list.{}".format(e))
        except ValueError as e:
            print("ValueError: The task_type cannot be converted to an integer.{}".format(e))
        except Exception as e:
            print("An unexpected error occurred: {}".format(e))

#的芯片授权一次申请全部，只看资源分配
def getAllAssignResourceInfo():
    #组织sql
    # 编写 SQL 查询
    sql_query = """
SELECT 
    engine_version,
    task_type, 
    business_type, 
    COUNT(*) AS count
FROM 
    ia_engine
WHERE 
    id LIKE '%#%'
    AND business_type != 1
GROUP BY 
    engine_version,
    task_type,
    business_type;
    """
    #获取数据
    bool_ret,str_ret = getSqllite3Data(sql_query)
    #组织数据
    # 解析输出
    output_lines = str_ret.strip().split('\n')
    info_message = "获取的数据 %s" % (output_lines)
    common.Log(info_message)
    handleSqlLiteData(output_lines)

#处理授权和分配的情况
def checkK3Engine(data):
    int_ret = common.EXIT_STATUS_INFO
    str_ret = ""
    #单个引擎类型资源分配的统计
    for key, value in data.items():
        #key表示tasktype
        if key == TaskType_vas: #处理Vas的业务
            vasAuthorNum = 0  #vas的授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取通用全结构化业务（20022）或者结构化业务授权（10039）或者昆仑3全结构化授权（10156）是否存在
                vasAuthorNum = getAuthorTotalNum(10039) + getAuthorTotalNum(20022) + getAuthorTotalNum(10156)
            else:  # 旧版本授权结构
                vasAuthorNum = global_authorize_info.get("IaBusinessVAS_V3", 0)
            vasAssignNum = value.get(BussinesType_Vas_Pic_V3, 0) + value.get(BussinesType_VAS_Video_V3, 0) #资源分配情况
            if vasAssignNum > 0 and vasAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "昆仑3结构化业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    vasAssignNum, vasAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "昆仑3结构化业务资源分配数量为【{}】,授权数量为【{}】；".format(
                    vasAssignNum, vasAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
        elif key == TaskType_fS: #处理fs的业务
            fsAuthorNum = 0  # vas的授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取通用全结构化业务（20022）或者人脸业务授权（10038）或者昆仑3全结构化授权（10156）是否存在
                fsAuthorNum = getAuthorTotalNum(10038) + getAuthorTotalNum(20022) + getAuthorTotalNum(10156)
            else:  # 旧版本授权结构
                fsAuthorNum = global_authorize_info.get("IaBusinessFA_V3", 0)
            fsAssignNum = value.get(BussinesType_FS_Pic_V3, 0) + value.get(BussinesType_FS_Video_V3, 0)  # 资源分配情况
            if fsAssignNum > 0 and fsAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "昆仑3人脸业务分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    fsAssignNum, fsAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "昆仑3人脸业务分配数量为【{}】,授权数量为【{}】；".format(
                    fsAssignNum, fsAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
        elif key == TaskType_ba: #处理行为分析的业务
            baAuthorNum = 0  # vas的授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取行为分析通用业务（10040）或者通用行为分析业务授权（20025）是否存在
                baAuthorNum = getAuthorTotalNum(10040) + getAuthorTotalNum(20025)
            else:  # 旧版本授权结构
                baAuthorNum = global_authorize_info.get("IaBusinessBA_V3", 0)
            # 资源分配情况
            baAssignNum = 0
            baAssignNum += value.get(BussinesType_BA_Supervise_V3, 0)
            baAssignNum += value.get(BussinesType_BA_PersonAnalysis_V3, 0)
            baAssignNum += value.get(BussinesType_BA_Action_V3, 0)
            baAssignNum += value.get(BussinesType_BA_PersonNumStatic_V3, 0)
            baAssignNum += value.get(BussinesType_BA_Safety_V3, 0)
            baAssignNum += value.get(BussinesType_BA_CommonVideo_V5, 0)  # 老板本没有，新版本才有
            if baAssignNum > 0 and baAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "昆仑3行为分析业务分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    baAssignNum, baAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "昆仑3行为分析业务分配数量为【{}】,授权数量为【{}】；".format(
                    baAssignNum, baAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
        elif key == TaskType_bas: #处理地铁行为分析业务
            basAuthorNum = 0  # vas的授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取行为分析地铁业务（20021）或者通用行为分析业务授权（20025）是否存在
                basAuthorNum = getAuthorTotalNum(20021) + getAuthorTotalNum(20025)
            else:  # 旧版本授权结构
                basAuthorNum = global_authorize_info.get("IaBusinessBAS_V3", 0)
            # 资源分配情况
            basAssignNum = 0
            basAssignNum += value.get(BussinesType_BA_Supervise_V3, 0)
            basAssignNum += value.get(BussinesType_BA_PersonAnalysis_V3, 0)
            basAssignNum += value.get(BussinesType_BA_Action_V3, 0)
            basAssignNum += value.get(BussinesType_BA_PersonNumStatic_V3, 0)
            basAssignNum += value.get(BussinesType_BA_Safety_V3, 0)
            basAssignNum += value.get(BussinesType_BA_CommonVideo_V5, 0)  # 老板本没有，新版本才有
            if basAssignNum > 0 and basAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "昆仑3地铁行为分析业务分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    basAssignNum, basAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "昆仑3地铁行为分析业务分配数量为【{}】,授权数量为【{}】；".format(
                    basAssignNum, basAuthorNum)
                common.Log(str_messgae)
    #汇总
    return int_ret,str_ret

def checkMLUEngine(data):
    int_ret = common.EXIT_STATUS_INFO
    str_ret = ""
    # 单个引擎类型资源分配的统计
    for key, value in data.items():
        # key表示tasktype
        if key == TaskType_vas:  # 处理Vas的业务
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                vasAuthorNum = 0  # vas的通用授权
                # 获取通用全结构化业务（20022）是否存在
                vasAuthorNum = getAuthorTotalNum(20022)
                vasAssignNum = value.get(BussinesType_Vas_Pic_V3, 0) + value.get(BussinesType_VAS_Video_V3, 0)  # 资源分配情况
                if vasAssignNum > 0 and vasAuthorNum == 0:
                    int_ret = common.EXIT_STATUS_ERROR
                    str_messgae = "寒武纪结构化业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                        vasAssignNum, vasAuthorNum)
                    str_ret += str_messgae
                else:
                    str_messgae = "寒武纪结构化业务资源分配数量为【{}】,授权数量为【{}】；".format(
                        vasAssignNum, vasAuthorNum)
                    common.Log(str_messgae)
                    str_ret += str_messgae
            else:  # 旧版本授权结构
                vasPicAuthorNum = 0  # vas的图片流授权数量
                vasVideoAuthorNum = 0  # vas的视频流授权数量
                vasVideoAuthorNum = global_authorize_info.get("5000003", 0)
                vasPicAuthorNum = global_authorize_info.get("5000002", 0)
                # 资源分配情况
                vasPicAssignNum = value.get(BussinesType_Vas_Pic_V3, 0)
                vasVideoAssignNum = value.get(BussinesType_VAS_Video_V3, 0)
                if vasPicAssignNum > 0 and vasPicAuthorNum == 0:
                    int_ret = common.EXIT_STATUS_ERROR
                    str_messgae = "寒武纪结构化图片流业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                        vasPicAssignNum, vasPicAuthorNum)
                    str_ret += str_messgae
                else:
                    str_messgae = "寒武纪结构化图片流业务资源分配数量为【{}】,授权数量为【{}】；".format(
                        vasPicAssignNum, vasPicAuthorNum)
                    common.Log(str_messgae)
                    str_ret += str_messgae
                if vasVideoAssignNum > 0 and vasVideoAuthorNum == 0:
                    int_ret = common.EXIT_STATUS_ERROR
                    str_messgae = "寒武纪结构化视频流业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                        vasVideoAssignNum, vasVideoAuthorNum)
                    str_ret += str_messgae
                else:
                    str_messgae = "寒武纪结构化视频流业务资源分配数量为【{}】,授权数量为【{}】；".format(
                        vasVideoAssignNum, vasVideoAuthorNum)
                    common.Log(str_messgae)
                    str_ret += str_messgae
        elif key == TaskType_fS:  # 处理fs的业务
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                fsAuthorNum = 0  # fs的通用授权
                # 获取通用全结构化业务（20022）是否存在
                fsAuthorNum = getAuthorTotalNum(20022)
                fsAssignNum = value.get(BussinesType_FS_Pic_V3, 0) + value.get(BussinesType_FS_Video_V3, 0)  # 资源分配情况
                if fsAssignNum > 0 and fsAssignNum == 0:
                    int_ret = common.EXIT_STATUS_ERROR
                    str_messgae = "寒武纪人脸业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                        fsAssignNum, fsAuthorNum)
                    str_ret += str_messgae
                else:
                    str_messgae = "寒武纪人脸业务资源分配数量为【{}】,授权数量为【{}】；".format(
                        fsAssignNum, fsAuthorNum)
                    common.Log(str_messgae)
                    str_ret += str_messgae
            else:  # 旧版本授权结构
                fsPicAuthorNum = 0  # vas的图片流授权数量
                fsVideoAuthorNum = 0  # vas的视频流授权数量
                fsVideoAuthorNum = global_authorize_info.get("5000001", 0)
                fsPicAuthorNum = global_authorize_info.get("5000000", 0)
                # 资源分配情况
                fsPicAssignNum = value.get(BussinesType_FS_Pic_V3, 0)
                fsVideoAssignNum = value.get(BussinesType_FS_Video_V3, 0)
                if fsPicAssignNum > 0 and fsPicAuthorNum == 0:
                    int_ret = common.EXIT_STATUS_ERROR
                    str_messgae = "寒武纪人脸图片流业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                        fsPicAssignNum, fsPicAuthorNum)
                    str_ret += str_messgae
                else:
                    str_messgae = "寒武纪人脸图片流业务资源分配数量为【{}】,授权数量为【{}】；".format(
                        fsPicAssignNum, fsPicAuthorNum)
                    common.Log(str_messgae)
                    str_ret += str_messgae
                if fsVideoAssignNum > 0 and fsVideoAuthorNum == 0:
                    int_ret = common.EXIT_STATUS_ERROR
                    str_messgae = "寒武纪人脸视频流业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                        fsVideoAssignNum, fsVideoAuthorNum)
                    str_ret += str_messgae
                else:
                    str_messgae = "寒武纪人脸视频流业务资源分配数量为【{}】,授权数量为【{}】；".format(
                        fsVideoAssignNum, fsVideoAuthorNum)
                    common.Log(str_messgae)
                    str_ret += str_messgae
        elif key == TaskType_ba:  # 处理行为分析的业务
            baAuthorNum = 0  # 授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取监管行为分析（20023）或者通用行为分析业务授权（20025）是否存在
                baAuthorNum = getAuthorTotalNum(20023) + getAuthorTotalNum(20025)
            else:  # 旧版本授权结构
                baAuthorNum = global_authorize_info.get("20023", 0) + global_authorize_info.get("20025", 0)
            # 资源分配情况
            baAssignNum = 0
            baAssignNum += value.get(BussinesType_BA_Supervise_V3, 0)
            baAssignNum += value.get(BussinesType_BA_PersonAnalysis_V3, 0)
            baAssignNum += value.get(BussinesType_BA_Action_V3, 0)
            baAssignNum += value.get(BussinesType_BA_PersonNumStatic_V3, 0)
            baAssignNum += value.get(BussinesType_BA_Safety_V3, 0)
            baAssignNum += value.get(BussinesType_BA_CommonVideo_V5, 0)  # 老板本没有，新版本才有
            if baAssignNum > 0 and baAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "寒武纪行为分析业务分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    baAssignNum, baAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "寒武纪行为分析业务分配数量为【{}】,授权数量为【{}】；".format(
                    baAssignNum, baAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
        elif key == TaskType_as: # 处理as的业务
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                asAuthorNum = 0  # as的授权数量
                # 获取全结构化授权业务（20022）是否存在
                asAuthorNum = getAuthorTotalNum(20022)
                #获取资源分配数量
                asAssignNum = 0
                asAssignNum += value.get(BussinesType_AS_Video_V3, 0)
                asAssignNum += value.get(BussinesType_AS_PicAll_V3, 0)
                asAssignNum += value.get(BussinesType_AS_PicSingle_V3, 0)
                if asAssignNum > 0 and asAuthorNum == 0:
                    int_ret = common.EXIT_STATUS_ERROR
                    str_messgae = "寒武纪全结构化分析业务分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                        asAssignNum, asAuthorNum)
                    str_ret += str_messgae
                else:
                    str_messgae = "寒武纪全结构化分析业务分配数量为【{}】,授权数量为【{}】；".format(
                        asAssignNum, asAuthorNum)
                    common.Log(str_messgae)
                    str_ret += str_messgae
            else:  # 旧版本授权结构。不存在as授权，直接报错
                str_messgae = "寒武纪全结构化业务授权为空"
                common.Log(str_messgae)
    return int_ret,str_ret

def checkGpuEngine(data):
    int_ret = common.EXIT_STATUS_INFO
    str_ret = ""
    # 单个引擎类型资源分配的统计
    for key, value in data.items():
        # key表示tasktype
        if key == TaskType_vas:  # 处理Vas的业务
            vasPicAuthorNum = 0  # vas的图片流授权数量
            vasVideoAuthorNum = 0  # vas的视频流授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取通用全结构化业务（20022） 机非人图片流业务授权【10049】  或者GPU全结构化授权（10157） 是否存在
                vasPicAuthorNum = getAuthorTotalNum(10049) + getAuthorTotalNum(20022) + getAuthorTotalNum(10157)
                # 机非人视频流业务授权【10048】 通用全结构化业务（20022）
                vasVideoAuthorNum = getAuthorTotalNum(10048) + getAuthorTotalNum(20022) + getAuthorTotalNum(10157)
            else:  # 旧版本授权结构
                #视频结构化业务80路【10048】/1000万张【10049】
                vasVideoAuthorNum = global_authorize_info.get("10048", 0)
                vasPicAuthorNum = global_authorize_info.get("10049", 0)
            # 资源分配情况
            vasPicAssignNum = value.get(BussinesType_Vas_Pic_V3, 0)
            vasVideoAssignNum = value.get(BussinesType_VAS_Video_V3, 0)
            if vasPicAssignNum > 0 and vasPicAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "GPU结构化图片流业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    vasPicAssignNum, vasPicAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "GPU结构化图片流业务资源分配数量为【{}】,授权数量为【{}】；".format(
                    vasPicAssignNum, vasPicAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
            if vasVideoAssignNum > 0 and vasVideoAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "GPU结构化视频流业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    vasVideoAssignNum, vasVideoAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "GPU结构化视频流业务资源分配数量为【{}】,授权数量为【{}】；".format(
                    vasVideoAssignNum, vasVideoAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
        elif key == TaskType_fS:  # 处理fs的业务
            fsPicAuthorNum = 0  # Fs的图片流授权数量
            fsVideoAuthorNum = 0  # Fs的视频流授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取通用全结构化业务（20022） 人脸图片流业务授权【10046】 或者GPU全结构化授权（10157） 是否存在
                fsPicAuthorNum = getAuthorTotalNum(10046) + getAuthorTotalNum(20022) + getAuthorTotalNum(10157)
                # 人脸视频流业务授权【10047】 通用全结构化业务（20022）
                fsVideoAuthorNum = getAuthorTotalNum(10047) + getAuthorTotalNum(20022) + getAuthorTotalNum(10157)
            else:  # 旧版本授权结构
                #人脸识别业务80路【10047】/400路(图)【10046】
                fsVideoAuthorNum = global_authorize_info.get("10047", 0)
                fsPicAuthorNum = global_authorize_info.get("10046", 0)
            # 资源分配情况
            fsPicAssignNum = value.get(BussinesType_FS_Pic_V3, 0)
            fsVideoAssignNum = value.get(BussinesType_FS_Video_V3, 0)
            if fsPicAssignNum > 0 and fsPicAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "GPU人脸图片流业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    fsPicAssignNum, fsPicAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "GPU人脸图片流业务资源分配数量为【{}】,授权数量为【{}】；".format(
                    fsPicAssignNum, fsPicAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
            if fsVideoAssignNum > 0 and fsVideoAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "GPU人脸视频流业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    fsVideoAssignNum, fsVideoAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "GPU人脸视频流业务资源分配数量为【{}】,授权数量为【{}】；".format(
                    fsVideoAssignNum, fsVideoAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
        elif key == TaskType_ba:  # 处理行为分析的业务
            baAuthorNum = 0  # 授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取行为分析业务授权【10043】或者通用行为分析业务授权（20025）是否存在
                baAuthorNum = getAuthorTotalNum(10043) + getAuthorTotalNum(20025)
            else:  # 旧版本授权结构
                #行为分析业务授权【10043】
                baAuthorNum = global_authorize_info.get("10043", 0)
            # 资源分配情况
            baAssignNum = 0
            baAssignNum += value.get(BussinesType_BA_Supervise_V3, 0)
            baAssignNum += value.get(BussinesType_BA_PersonAnalysis_V3, 0)
            baAssignNum += value.get(BussinesType_BA_Action_V3, 0)
            baAssignNum += value.get(BussinesType_BA_PersonNumStatic_V3, 0)
            baAssignNum += value.get(BussinesType_BA_Safety_V3, 0)
            baAssignNum += value.get(BussinesType_BA_CommonVideo_V5, 0)  # 老板本没有，新版本才有
            if baAssignNum > 0 and baAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "GPU行为分析业务分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    baAssignNum, baAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "GPU行为分析业务分配数量为【{}】,授权数量为【{}】；".format(
                    baAssignNum, baAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
        elif key == TaskType_bas: #处理地铁行为分析业务
            basAuthorNum = 0  # bas的授权数量
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                # 获取地铁行为分析业务授权【20019】或者通用行为分析业务授权（20025）是否存在
                basAuthorNum = getAuthorTotalNum(20019) + getAuthorTotalNum(20025)
            else:  # 旧版本授权结构
                basAuthorNum = global_authorize_info.get("20019", 0)
            # 资源分配情况
            basAssignNum = 0
            basAssignNum += value.get(BussinesType_BA_Supervise_V3, 0)
            basAssignNum += value.get(BussinesType_BA_PersonAnalysis_V3, 0)
            basAssignNum += value.get(BussinesType_BA_Action_V3, 0)
            basAssignNum += value.get(BussinesType_BA_PersonNumStatic_V3, 0)
            basAssignNum += value.get(BussinesType_BA_Safety_V3, 0)
            basAssignNum += value.get(BussinesType_BA_CommonVideo_V5, 0)  # 老板本没有，新版本才有
            if basAssignNum > 0 and basAuthorNum == 0:
                int_ret = common.EXIT_STATUS_ERROR
                str_messgae = "GPU地铁行为分析业务分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                    basAssignNum, basAuthorNum)
                str_ret += str_messgae
            else:
                str_messgae = "GPU地铁行为分析业务分配数量为【{}】,授权数量为【{}】；".format(
                    basAssignNum, basAuthorNum)
                common.Log(str_messgae)
                str_ret += str_messgae
        elif key == TaskType_as:  # 处理as的业务
            if len(global_licenseUsedInfo) > 0:  # 新版本授权结构
                asAuthorNum = 0  # as的授权数量
                # 获取全结构化授权业务（20022）是否存在
                asAuthorNum = getAuthorTotalNum(20022)
                # 获取资源分配数量
                asAssignNum = 0
                asAssignNum += value.get(BussinesType_AS_Video_V3, 0)
                asAssignNum += value.get(BussinesType_AS_PicAll_V3, 0)
                asAssignNum += value.get(BussinesType_AS_PicSingle_V3, 0)
                if asAssignNum > 0 and asAuthorNum == 0:
                    int_ret = common.EXIT_STATUS_ERROR
                    str_messgae = "GPU全结构化分析业务分配数量为【{}】,授权数量为【{}】，不匹配；".format(
                        asAssignNum, asAuthorNum)
                    str_ret += str_messgae
                else:
                    str_messgae = "GPU全结构化分析业务分配数量为【{}】,授权数量为【{}】；".format(
                        asAssignNum, asAuthorNum)
                    common.Log(str_messgae)
                    str_ret += str_messgae
            else:  # 旧版本授权结构。不存在as授权，直接报错
                str_messgae = "GPU全结构化业务授权为空"
                common.Log(str_messgae)
    return int_ret, str_ret

def checkAxEngine(data):
    #只有新版本的即可
    int_ret = common.EXIT_STATUS_INFO
    str_ret = ""
    if len(global_licenseUsedInfo) == 0:  # 新版本授权结构
        str_messgae = "业务授权为空"
        common.Log(str_messgae)
        int_ret = common.EXIT_STATUS_WARNING
        str_ret = "当前版本不支持爱芯授权与资源分配匹配巡检；"
        return int_ret,str_ret
    # 单个引擎类型资源分配的统计
    allStructAssignNum = 0 #人脸和结构化的资源数
    baAssignNum = 0 #行为分析的资源数
    for key, value in data.items():
        # key表示tasktype
        if key == TaskType_vas:  # 处理Vas的业务
            allStructAssignNum = value.get(BussinesType_Vas_Pic_V3, 0) + value.get(BussinesType_VAS_Video_V3,
                                                                                 0)  # 资源分配情况
        elif key == TaskType_fS:  # 处理fs的业务
            allStructAssignNum = value.get(BussinesType_FS_Pic_V3, 0) + value.get(BussinesType_FS_Video_V3,
                                                                                  0)  # 资源分配情况
        elif key == TaskType_ba:  # 处理行为分析的业务
            baAssignNum = getAuthorTotalNum(20023) + getAuthorTotalNum(20025)
        elif key == TaskType_as:  # 处理as的业务
            allStructAssignNum += value.get(BussinesType_AS_Video_V3, 0)
            allStructAssignNum += value.get(BussinesType_AS_PicAll_V3, 0)
            allStructAssignNum += value.get(BussinesType_AS_PicSingle_V3, 0)
    #获取授权情况 通用行为分析业务授权【20025】、通用全结构化授权【20022】
    allStructAuthorNum = getAuthorTotalNum(20022)
    baAuthorNum = getAuthorTotalNum(20025)
    #判断授权分配情况
    if allStructAssignNum > 0 and allStructAuthorNum == 0:
        int_ret = common.EXIT_STATUS_ERROR
        str_messgae = "爱芯人机非人脸业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
            allStructAssignNum, allStructAuthorNum)
        str_ret += str_messgae
    else:
        str_messgae = "爱芯人机非人脸业务资源分配数量为【{}】,授权数量为【{}】；".format(
            allStructAssignNum, allStructAuthorNum)
        common.Log(str_messgae)
        str_ret += str_messgae
    if baAssignNum > 0 and baAuthorNum == 0:
        int_ret = common.EXIT_STATUS_ERROR
        str_messgae = "爱芯行为分析业务资源分配数量为【{}】,授权数量为【{}】，不匹配；".format(
            baAssignNum, baAuthorNum)
        str_ret += str_messgae
    else:
        str_messgae = "爱芯行为分析业务资源分配数量为【{}】,授权数量为【{}】；".format(
            baAssignNum, baAuthorNum)
        common.Log(str_messgae)
        str_ret += str_messgae
    return int_ret,str_ret

#遍历缓存下来的资源分配情况，确认是否存在授权
#返回对应的结果
def checkAssignResourceHaveAuthor():
    int_ret = common.EXIT_STATUS_INFO
    str_ret = ""
    # 处理爱芯的数据
    if EngineType_aixin in global_statics_data:
        int_ret,str_engine_ret = checkAxEngine(global_statics_data[EngineType_aixin])
        str_ret += str_engine_ret
    # 处理k3数据
    if EngineType_k3 in global_statics_data:
        int_ret, str_engine_ret = checkK3Engine(global_statics_data[EngineType_k3])
        str_ret += str_engine_ret
    # 处理mlu数据
    if EngineType_MLU in global_statics_data:
        int_ret, str_engine_ret = checkMLUEngine(global_statics_data[EngineType_MLU])
        str_ret += str_engine_ret
    # 处理GPU数据
    if EngineType_gpu in global_statics_data:
        int_ret, str_engine_ret = checkGpuEngine(global_statics_data[EngineType_gpu])
        str_ret += str_engine_ret
    return int_ret, str_ret

#巡检入口
def mainCheck():
    int_ret = common.EXIT_STATUS_INFO
    str_ret = ""
    # 获取授权情况
    # 通过发送老接口查看是否能正常返回，用来判断
    if getLicenseUsedInfo() == True:
        if len(global_licenseUsedInfo) == 0:  # 表示没有获取到授权信息
            int_ret = common.EXIT_STATUS_ERROR
            str_ret = "授权信息为空"
    else:  # 老版本
        if getAuthorizeInfo() == True and getAuthorizeDetailInfoGPU() == True and getAuthorizeDetailInfoMLU() == True:
            if len(global_authorize_info) == 0:  # 表示没有获取到授权信息
                int_ret = common.EXIT_STATUS_ERROR
                str_ret = "授权信息为空"
        else:
            # 将授权新返回
            str_ret = "巡检授权信息出现问题,请排查日志"
            int_ret = common.EXIT_STATUS_WARNING
    if int_ret != common.EXIT_STATUS_INFO:
        # 将授权新返回
        print str_ret
        sys.exit(int_ret)

    # 获取资源分配的情况
    getAllAssignResourceInfo()
    if len(global_statics_data) == 0:
        str_ret = "资源分配获取为空"
        int_ret = common.EXIT_STATUS_WARNING
    if int_ret != common.EXIT_STATUS_INFO:
        # 将授权新返回
        print str_ret
        sys.exit(int_ret)
    # 判断是否存在异常
    int_ret,str_ret = checkAssignResourceHaveAuthor()
    # 将授权新返回
    print str_ret
    sys.exit(int_ret)

mainCheck()





