﻿# Python 2.7 示例脚本
import re
import os
import sys
import codecs
import subprocess
import json
import urllib2
import urllib
import platform

EXIT_STATUS_INFO=0
EXIT_STATUS_WARNING=1
EXIT_STATUS_ERROR=2
DATA_PATH="/opt/iacheck"
SHELL_LOG="%s/bin/common_def/Log.sh" % (DATA_PATH)

charset = os.getenv('LANG') or os.getenv('LC_CTYPE')
# print("Charset from environment: ",charset)

def GetIamPgPort():
    command1 = ['iamcfg', 'list']
    command2 = ['grep VMDevType']
    proc1 = subprocess.Popen(command1, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    proc2 = subprocess.Popen(command2, stdin=proc1.stdout, stdout=subprocess.PIPE, stderr=subprocess.PIPE,shell=True)
    proc1.stdout.close()
    output2, error2  = proc2.communicate()
    # 解析配置项
    split_list = output2.split()
    if 2 <= len(split_list) :
        str_value = split_list[2]
        Log("当前产品是：%s" % str_value)
        if "VDS" in str_value:
            return 5442
        else:
            return 5432
    if error2:
        error_message = "iam获取的VMDevType配置项失败，错误信息：【%s】" % (error2)
        Log(error_message)
        return 5432

def GetUnicodeStr(byte_string):
    try:
        decoded_string = byte_string.decode('utf-8')
        return decoded_string
    except Exception as e :
         Log("utf-8 decode Exception type: %s, Description: %s" % (e.__class__.__name__, str(e)))
    return byte_string
        
def GetUtf8Str(byte_string):
    try:
        encoded_string = byte_string.encode('utf-8')
        return encoded_string
    except Exception as e :
         Log("utf-8 encode Exception type: %s, Description: %s" % (e.__class__.__name__, str(e)))
    return byte_string
    
def GetDataFromUrl(url) : 
    http_response_result=""
    try:
        response = urllib2.urlopen(url)
        http_response_result = response.read()
    except urllib2.URLError as e:
        Log("URL Error: %s" % e.reason)
    except urllib2.HTTPError as e:
        Log("HTTP Error: %s" % e.code, e.reason)
    return http_response_result

def PostDataFromUrl(url,data) :
    http_response_result=""
    try:
        # 将数据编码为 URL 格式
        encoded_data = urllib.urlencode(data)
        # 创建请求对象
        request = urllib2.Request(url, encoded_data)
        response = urllib2.urlopen(request)
        http_response_result = response.read()
    except urllib2.URLError as e:
        print("URL Error: ", e.reason)
    except urllib2.HTTPError as e:
        print("HTTP Error: ", e.code, e.reason)
    return http_response_result

def ParseJsonData(str_json_data) : 
    json_object=""
    try :
        json_object = json.loads(str_json_data)
    except Exception as e :
         Log("Exception type: %s, Description: %s" % (e.__class__.__name__, str(e)))
    return json_object
    
def GetMdIp() : 
    ipv4_pattern = re.compile(r'^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$')
    md_ip_config_cmd = subprocess.Popen(['iamcfg', 'list', '-d', 'iam', '-g', 'Global', '-i', 'MD-Balance-IP'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    md_ip_info = subprocess.Popen('grep MD-Balance-IP', stdin=md_ip_config_cmd.stdout, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
    md_ip_config_cmd.stdout.close()
    stdout, stderr = md_ip_info.communicate()  # 等待命令执行完成并获取输出
    split_list = stdout.split()
    if 2 <= len(split_list) : 
        md_ip = split_list[2]
        if ipv4_pattern.match(md_ip) is not None : 
            return md_ip

def Log(log_message) :
    shell_cmd = "%s \"%s\"" % (SHELL_LOG, log_message)
    try:
        output = subprocess.check_output([shell_cmd], shell=True)
    except subprocess.CalledProcessError as e:
        print("Error:", e)

### 判断是否支持数据统计
### return true: 支持数据统计。false：不支持数据统计
def IsSupportDataStatistics():
    bool_support_check = False
    try:
       # 定义要执行的命令
        command1 = ['iamcfg', 'list']
        command2 = ['grep Statistics-Report-Switch']
        # 获取配置项
        proc1 = subprocess.Popen(command1, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        proc2 = subprocess.Popen(command2, stdin=proc1.stdout, stdout=subprocess.PIPE, stderr=subprocess.PIPE,shell=True)
        proc1.stdout.close()
        output2, error2  = proc2.communicate()  # 等待命令执行完成并获取输出
        info_message = "iam获取的Statistics-Report-Switch配置项信息为[%s]" % (output2)
        Log(info_message)
        if output2:
            # 解析配置项
            split_list = output2.split()
            if 2 <= len(split_list) :
                str_value = split_list[2]
                if str_value == "1" :
                    bool_support_check = True
                else:
                    info_message = "iam获取的Statistics-Report-Switch配置项值为[%s]，请调整后再次巡检" % (str_value)
                    Log(info_message)
        if error2:
            bool_support_check = False
            error_message = "iam获取的Statistics-Report-Switch配置项失败，错误信息：【%s】" % (error2)
            Log(error_message)
    except Exception as e:
        bool_support_check = False
        error_message = "IsSupportLossDataCheck Exception occurred: %s" % str(e)
        Log(error_message)
    return bool_support_check
    
### 判断巡检模式，是否板特性和非看板特性两种
### return true: 支持数据看板，false：不支持数据看板
def IsSupportKanbanCheckMode():
    bool_support_kanban = False
    try:
         # 定义要执行的命令
        command1 = ['iamcfg', 'list']
        command2 = ['grep Statistics-Report-Quickly']
        # 获取配置项
        proc1 = subprocess.Popen(command1, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        proc2 = subprocess.Popen(command2, stdin=proc1.stdout, stdout=subprocess.PIPE, stderr=subprocess.PIPE,shell=True)
        proc1.stdout.close()
        output2, error2 = proc2.communicate()  # 等待命令执行完成并获取输出
        info_message = "iam获取的Statistics-Report-Quickly配置项信息为[%s]" % (output2)
        Log(info_message)
        if output2: #不为空
            bool_support_kanban = True
        else:
            bool_support_kanban = False
    except Exception as e:
        bool_support_kanban = False
        error_message = "IsSupportKanbanCheckMode Exception occurred: %s" % str(e)
        Log(error_message)
    return bool_support_kanban

### 执行PG数据库命令
### return 数据查询结果，调用该接口请自行处理异常，接口内部不做异常处理
def PorcessPgSqlCommand(str_db_name, str_db_user, str_db_host, str_db_port, str_passwd, str_mul_line_sql):
    # 将多行 SQL 查询转换为单行 SQL 查询
    str_single_line_sql = str_mul_line_sql.replace('\n', ' ').strip()
    #区分平台执行不同的sql命令
    os_type = platform.system()
    if os_type == 'Windows':
        # 组织sql
        psql_command = 'psql.exe -d {} -U {} -h {} -p {} -t -c "{}"'.format(
            str_db_name, str_db_user, str_db_host, str_db_port, str_single_line_sql
        )
    else:
        if (os.path.isfile("/home/postgres/pgsql/bin/psql")):
            psql_command = '/home/postgres/pgsql/bin/psql -d {} -U {} -h {} -p {} -t -c "{}"'.format(
                str_db_name, str_db_user, str_db_host, str_db_port, str_single_line_sql
            )
        else:
            psql_command = '/program/bin/psql -d {} -U {} -h {} -p {} -t -c "{}"'.format(
                str_db_name, str_db_user, str_db_host, str_db_port, str_single_line_sql
            )
    info_message = "访问数据库：%s，用户：%s，访问地址：%s，访问端口：%s，执行sql：%s" % (str_db_name, str_db_user, str_db_host, str_db_port, str_single_line_sql)
    Log(info_message)
    # 执行 psql 命令
    # 使用 subprocess.Popen 来执行命令
    # 设置环境变量以传递密码和字符编码
    env = os.environ.copy()
    env['PGPASSWORD'] = str_passwd
    env['PGCLIENTENCODING'] = 'UTF8'
    try:
        # 执行psql命令并捕获输出
        process = subprocess.Popen(psql_command, stdout=subprocess.PIPE, stderr=subprocess.PIPE, env=env, shell=True)
        stdout, stderr = process.communicate()
        if process.returncode != 0:
            error_message = "sql执行失败，错误码{}".format(process.returncode)
            Log(error_message)
            return False,""
        else:
            #stdout=stdout.rstrip('\r\n') pq返回的结果多出两个空行，占时去除
            info_message = "sql执行结果为：{}".format(stdout)
            Log(info_message)
            return True, stdout
    except Exception as e:
        error_message = "sql执行异常：{}".format(e)
        Log(error_message)
        return False, ""