﻿import sys
import common
import time
import subprocess

#场景大图的全局定义
global_panoramaTypeVehicle_001 = "001"  #车辆全景图type
global_panoramaTypeVehicle_01 = "01"  #车辆全景图type
global_panoramaTypePerson = "14"    #非机动车和人体的全景图type
global_panoramaTypeNonmotor = "14"  #非机动车全景图type
global_panoramaTypeFace = "14"      #人脸全景图type

#目标小图的全局定义
global_targetTypeVehicle_009 = "009"  #车辆目标小图type
global_targetTypeVehicle_09 = "09"    #车辆目标小图type
global_targetTypePerson = "10"        #人体的目标小图type
global_targetTypeNonmotor = "12"      #非机动车目标小图type
global_targetTypeFace = "11"          #人脸目标小图type

#车牌图片
global_plate_code_pic_02 = "02"       #车牌图
global_plate_code_pic_002 = "002"     #车牌图

#通用全局变量
global_pic_task_id = ""             #任务ID
global_pic_TollgateCode = ""        #卡口编码
global_pic_CamCode = ""             #相机名称
global_pic_record_id = ""           #数据的recordid

# 定义字典来缓存异常条目和异常的数目
global_vehicle_balacne_exception_map = {}
global_person_balacne_exception_map = {}
global_nonmontor_balacne_exception_map = {}
global_face_balacne_exception_map = {}
global_allstruct_balacne_exception_map = {}

# 定义异常类型
EXCEPTION_TYPES = {
    "total_num": "巡检的数据数",
    "get_md_message_detail_error_num": "获取mq的message的详情信息失败个数",
	"parser_md_message_detail_error_num": "解析mq的message的详情信息失败个数",
    "get_object_info_error_num": "获取Object信息异常个数",  # 人机非分隔@@@符号错误数量
    "large_image_missing_num": "大图缺失个数",
    "small_image_missing_num": "小图缺失个数",
    "coordinate_missing_num": "坐标缺失个数",
    "coordinate_format_error_num": "坐标格式错误个数",
	"features_contains_num": "存在features字段个数",
}

# 函数：记录异常
def record_exception(exception_map,exception_type):
    if exception_type in exception_map:
        exception_map[exception_type] += 1
    else:
        exception_map[exception_type] = 1

# 定义分辨率对应的像素范围
global_resolutions = {
    "720p": (1280, 720),
    "1080p": (1920, 1080),
    "2K_2048x1080": (2048, 1080),
    "2K_2560x1440": (2560, 1440),
    "4K_UHD": (3840, 2160),
    "4K_DCI": (4096, 2160)
}

#获取真实图片分辨率
def GetPicResolutions(json_message_object):
    #声明全局变量，用来修改
    global global_max_height
    global global_max_width
    # 获取初始的最大分辨率范围
    global_max_width = max(res[0] for res in global_resolutions.values())
    global_max_height = max(res[1] for res in global_resolutions.values())
    #获取内部数据
    if json_message_object:  # 不为空
        sub_image_list = json_message_object["SubImageList"]
        sub_image_info_objects = sub_image_list["SubImageInfoObject"]
        for sub_image in sub_image_info_objects:
            image_type = sub_image["Type"]
            #是否是场景大图
            if image_type == global_panoramaTypeVehicle_001 or image_type == global_panoramaTypeVehicle_01 or image_type == global_panoramaTypePerson :
                pic_width = sub_image["Width"]
                pic_height = sub_image["Height"]
                if 0 < pic_width and  0 < pic_height :
                    global_max_width = pic_width
                    global_max_height = pic_height
                break
    info_message = "MQ获取的场景大图存在分辨率信息，当前的设置的图片的范围为：（%d,%d）" % (
    global_max_width, global_max_height)
    common.Log(info_message)

#判断坐标是否是像素坐标类型
def IsPixelCoordinate(json_message_object):
    bool_pixel_coordinate = True
    if json_message_object : #不为空
        # 获取坐标值
        x1 = json_message_object["LeftTopX"]
        y1 = json_message_object["LeftTopY"]
        x2 = json_message_object["RightBtmX"]
        y2 = json_message_object["RightBtmY"]
        # 判断是否存在分辨率信息，如果不存在，则使用字典类型
        GetPicResolutions(json_message_object)
        info_message = "MQ获取的场景大图,最终的图片的范围为：（%d,%d）" % (global_max_width, global_max_height)
        common.Log(info_message)
        # 判断坐标是否在所有分辨率的最大范围内
        bool_pixel_coordinate = 0 <= x1 <= global_max_width and 0 <= y1 <= global_max_height and 0 <= x2 <= global_max_width and 0 <= y2 <= global_max_height
    return bool_pixel_coordinate

#判断坐标是否存在
def IsContaisCoordinate(json_message_object):
    bool_contais_coordinate = True
    if json_message_object : #不为空
        # 获取坐标值
        leftTopX = json_message_object["LeftTopX"]
        leftTopY = json_message_object["LeftTopY"]
        rightBtmX = json_message_object["RightBtmX"]
        rightBtmY = json_message_object["RightBtmY"]
        info_message = "MQ获取的场景坐标为：左上点（%d,%d），右下点（%d,%d）" % (leftTopX, leftTopY,rightBtmX,rightBtmY)
        common.Log(info_message)
        # 判断坐标是否存在
        if rightBtmX - leftTopX <= 1 or rightBtmY - leftTopY <= 1:
            bool_contais_coordinate = False
    return bool_contais_coordinate

#是否启用小图检查
def IsSamllPicCheakFalg() :
    bool_small_pic_check = False
    try:
        pic_analyse_mode_config_cmd = subprocess.Popen(['iamcfg', 'list', '-d', 'iae', '-g', 'AllStruct', '-i', 'struct-pic-second-analyse-mode'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        pic_analyse_mode_info = subprocess.Popen('grep struct-pic-second-analyse-mode', stdin=pic_analyse_mode_config_cmd.stdout, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
        pic_analyse_mode_config_cmd.stdout.close()
        stdout, stderr = pic_analyse_mode_info.communicate()  # 等待命令执行完成并获取输出
        split_list = stdout.split()
        info_message = "iam获取的struct-pic-second-analyse-mode配置项信息为：[%s]" % (stdout)
        common.Log(info_message)
        if 2 <= len(split_list) :
            pic_analyse_mode = split_list[2]
            if pic_analyse_mode == "small" :
                bool_small_pic_check = True
    except Exception as e:
        error_message = "IsSamllPicCheakFalg Exception occurred: %s" % str(e)
        common.Log(error_message)
    return bool_small_pic_check


#判断是否存在Feature信息
def IsContainsFeaturesInfo(json_message_object):
    bool_contains_features_info = False
    if json_message_object : #不为空
        pic_features_info= json_message_object["Features"]
        if pic_features_info: #不为空
            bool_contains_features_info = True
    return bool_contains_features_info

#校验是否存在大图信息
def IsContainsBigPicInfo(json_message_object, target_type):
    bool_contains_big_picInfo=False
    if json_message_object:  # 不为空
        sub_image_list = json_message_object["SubImageList"]
        sub_image_info_objects = sub_image_list["SubImageInfoObject"]
        for sub_image in sub_image_info_objects:
            image_type = sub_image["Type"]
            storage_path = sub_image["StoragePath"]
            if target_type == "vehicle":  # 机动车
                if image_type == global_panoramaTypeVehicle_001 or image_type == global_panoramaTypeVehicle_01:
                    bool_contains_big_picInfo = storage_path != ""
                    break
            elif target_type == "nonmotor" :  # 非机动车
                if image_type == global_panoramaTypeNonmotor:
                    bool_contains_big_picInfo = storage_path != ""
                    break
            elif target_type == "person":  # 人体数据
                if image_type == global_panoramaTypePerson:
                    bool_contains_big_picInfo = storage_path != ""
                    break
            elif target_type == "face":  # 人脸数据
                if image_type == global_panoramaTypeFace:
                    bool_contains_big_picInfo = storage_path != ""
                    break
    return bool_contains_big_picInfo


#是否存在小图信息
def IsContainsSmallPicInfo(json_message_object, target_type):
    bool_contains_Small_picInfo = False
    if json_message_object:  # 不为空
        sub_image_list = json_message_object["SubImageList"]
        sub_image_info_objects = sub_image_list["SubImageInfoObject"]
        for sub_image in sub_image_info_objects:
            image_type = sub_image["Type"]
            storage_path = sub_image["StoragePath"]
            if target_type == "vehicle":  # 机动车
                if image_type == global_targetTypeVehicle_009 or image_type == global_targetTypeVehicle_09:
                    bool_contains_Small_picInfo = storage_path != ""
                    break
            elif target_type == "nonmotor":  # 非机动车
                if image_type == global_targetTypeNonmotor:
                    bool_contains_Small_picInfo = storage_path != ""
                    break
            elif target_type == "person":  # 人体数据
                if image_type == global_targetTypePerson:
                    bool_contains_Small_picInfo = storage_path != ""
                    break
            elif target_type == "face":  # 人脸数据
                if image_type == global_targetTypeFace:
                    bool_contains_Small_picInfo = storage_path != ""
                    break
    return bool_contains_Small_picInfo


#是否包含车牌小图
def IsContainsPlateNoPicInfo(json_message_object):
    bool_contains_PlateNo_Info = False
    if json_message_object:  # 不为空
        sub_image_list = json_message_object["SubImageList"]
        sub_image_info_objects = sub_image_list["SubImageInfoObject"]
        for sub_image in sub_image_info_objects:
            image_type = sub_image["Type"]
            storage_path = sub_image["StoragePath"]
            if image_type == global_plate_code_pic_02 or image_type == global_plate_code_pic_002:
                bool_contains_PlateNo_Info = storage_path == ""
                break
    return bool_contains_PlateNo_Info

#获取公共信息，用来打印日志，获取任务ID、相机ID
def GetCommonInfoObjects(json_message_object):
    # 使用 global 关键字声明这些变量是全局变量
    global global_pic_TollgateCode
    global global_pic_CamCode
    global global_pic_record_id

    if json_message_object : #不为空
        if "CamCode" in json_message_object:
            global_pic_CamCode = common.GetUtf8Str(json_message_object["CamCode"])
        if "RecordID" in json_message_object:
            global_pic_record_id = common.GetUtf8Str(json_message_object["RecordID"])
        if "TollgateCode" in json_message_object:
            global_pic_TollgateCode = common.GetUtf8Str(json_message_object["TollgateCode"])

        if global_pic_CamCode == "" and global_pic_TollgateCode == "":
            if "CameraID" in json_message_object:
                global_pic_CamCode = common.GetUtf8Str(json_message_object["CameraID"])
                global_pic_TollgateCode = global_pic_CamCode
        if global_pic_record_id == "":
            global_pic_record_id = "unknow"

#按照类型获取数据
def GetBalanceMqMessage(str_topic_name):
    # 获取MD的IP
    md_ip = common.GetMdIp()
    # 获取当前时间的时间戳（毫秒）
    end_time_millis = int(time.time()) * 1000
    # 获取当前时间前1分钟的时间戳（毫秒）
    start_time_millis = end_time_millis - 60 * 1000
    # 动态组织URL
    url = "http://%s:8050/message/queryMessageByTopic.query?begin=%d&end=%d&topic=%s" % (
    md_ip, start_time_millis, end_time_millis, str_topic_name)
    # 访问MQ数据
    json_result = common.GetDataFromUrl(url)
    if (json_result == ""):
        info_message = "组织的MQ数据请求URL为：%s，返回的数据为空：%s" % (url,common.GetUtf8Str(json_result))
        common.Log(info_message)
        return ""
    # 解析MQ返回的结果
    json_object = common.ParseJsonData(json_result)
    if 0 == len(json_object):
        return ""

    if ("data" in json_object):
        json_arr_group = json_object["data"]
        info_message = "组织的MQ数据请求URL为：%s，返回的数据为：%s" % (url,common.GetUtf8Str(json_object))
        common.Log(info_message)
        return json_arr_group
    else:
        common.Log(json_result)
        return ""

#获取数据的datail的详情
def GetBalanceMqMessageDetail(str_topic_name,str_msgId):
    str_message_body=""
    bool_parser_error=False
    # 获取MD的IP
    md_ip = common.GetMdIp()
    # 获取数据详情
    url = "http://%s:8050/message/viewMessage.query?msgId=%s&topic=%s" % (md_ip, str_msgId, str_topic_name)
    info_message = "http的url请求为：%s" % (common.GetUtf8Str(url))
    common.Log(info_message)
    # 访问MQ数据
    json_msg_result = common.GetDataFromUrl(url)
    # 解析MQ返回的结果
    json_msg_object = common.ParseJsonData(json_msg_result)
    json_msg_object_length = len(json_msg_object)
    if 0 == json_msg_object_length:
        error_message = "MQ主题【%s】主题数据详情获取为空" % (str_topic_name)
        common.Log(error_message)
        return str_message_body,bool_parser_error
    # 提取 messageView 中的 messageBody 字段
    str_original_message_body = json_msg_object.get('data', {}).get('messageView', {}).get('messageBody', '')
    # 针对机非人进行特别处理
    if str_topic_name == "FACE_BALANCE_STK":
        str_message_body=str_original_message_body
    else: #机非人数据
        # 提取message信息，将VasPicTask-647446627736354822@@@ 任务id和@@@去除
        # 找到 '@@@' 的位置
        int_index_message = str_original_message_body.find('@@@')
        # 如果找到了 '@@@'，则截取 '@@@' 之后的部分
        if int_index_message != -1:
            # 使用 global 关键字声明这些变量是全局变量
            global global_pic_task_id
            global_pic_task_id = common.GetUtf8Str(str_original_message_body[:int_index_message])
            str_message_body = str_original_message_body[int_index_message + 3:]  # index + 3 是因为 '@@@' 有三个字符
        else:
            if str_topic_name == "ALLSTRUCT_BALANCE_STK":
                str_message_body = str_original_message_body
            else:
                bool_parser_error = True
                # 如果没有找到 '@@@'，则返回原字符串
                str_error_message = "MQ主题【%s】主题数据【%s】，不存在taskid字段，数据结构异常" % (str_topic_name,common.GetUtf8Str(str_original_message_body))
                common.Log(str_error_message)

    return str_message_body,bool_parser_error


#数据格式校验，包括接入数据和输出数据
def CheckVehicleBalanceStkData(balacne_exception_map):
    bool_check_result=True
    # 主题名称
    topicName = "VEHICLE_BALANCE_STK"
    json_arr_group = GetBalanceMqMessage(topicName)
    group_arr_length = len(json_arr_group)
    # 如果数据为0，结束运行
    if 0 == group_arr_length:
        bool_check_result = False
        error_message = "MQ机动车数据获取失败"
        common.Log(error_message)
        return bool_check_result
    # 增加数据限制
    if group_arr_length > 200:
        group_arr_length = 200

    for index in range(group_arr_length):
        record_exception(balacne_exception_map, "total_num")  # 记录巡检数据量
        curren_json_object = json_arr_group[index]
        str_msgId = curren_json_object["msgId"]
        #获取数据详情
        str_message_body,bool_parser_error = GetBalanceMqMessageDetail(topicName,str_msgId)
        if str_message_body == "":
            if bool_parser_error:
                record_exception(balacne_exception_map, "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            else:
                record_exception(balacne_exception_map, "get_md_message_detail_error_num")  # 记录获取mq的message的详情信息失败个数
            continue
        #解析当前json
        json_message_body_object = common.ParseJsonData(str_message_body)
        if len(json_message_body_object) == 0:
            error_message = "MQ解析messageBody为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map, "parser_md_message_detail_error_num") #解析mq的message的详情信息失败个数
            continue
        #提取关键数据
        motor_vehicle_object = json_message_body_object["MotorVehicleObject"][0]
        if motor_vehicle_object == "":
            error_message = "MQ解析MotorVehicleObject为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,"parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        info_message = "MQ解析MotorVehicleObject成功，MQ返回的数据信息：%s" % (json_message_body_object)
        common.Log(info_message)
        #获取公共信息，用来日志输出
        GetCommonInfoObjects(motor_vehicle_object)
        #校验大图数据是否存在
        if False == IsContainsBigPicInfo(motor_vehicle_object, "vehicle"):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的大图数据为空" % (global_pic_CamCode,global_pic_TollgateCode,global_pic_task_id,global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,"large_image_missing_num")  # 大图缺失失败个数
        #校验小图数据是否存在
        if IsSamllPicCheakFalg(): #需要校验小图
            if False == IsContainsSmallPicInfo(motor_vehicle_object, "vehicle"):
                error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的小图数据为空" % (global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
                common.Log(error_message)
                record_exception(balacne_exception_map,"small_image_missing_num")  #小图缺失失败个数
        #校验是否存在features字段
        if True == IsContainsFeaturesInfo(motor_vehicle_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的存在Features字段" % (global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,"features_contains_num")  # 存在Features字段
        #校验坐标是否存在
        if False ==IsContaisCoordinate(motor_vehicle_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的小图坐标为空" % (global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,"coordinate_missing_num")  # 坐标缺失
            continue
        #校验坐标格式是否正确
        if False ==IsPixelCoordinate(motor_vehicle_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的坐标格式错误" % (global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,"coordinate_format_error_num")  # 坐标不是像素坐标
    return bool_check_result

# 数据格式校验，包括接入数据和输出数据
def CheckNonmotorBalanceStkData(balacne_exception_map):
    bool_check_result = True
    # 主题名称
    topicName = "NONMOTOR_BALANCE_STK"
    json_arr_group = GetBalanceMqMessage(topicName)
    group_arr_length = len(json_arr_group)
    # 如果数据为0，结束运行
    if 0 == group_arr_length:
        bool_check_result = False
        error_message = "MQ非机动车数据获取失败"
        common.Log(error_message)
        return bool_check_result
    # 增加数据限制
    if group_arr_length > 200:
        group_arr_length = 200

    for index in range(group_arr_length):
        record_exception(balacne_exception_map, "total_num")  # 记录巡检数据量
        curren_json_object = json_arr_group[index]
        str_msgId = curren_json_object["msgId"]
        # 获取数据详情
        str_message_body, bool_parser_error = GetBalanceMqMessageDetail(topicName, str_msgId)
        if str_message_body == "":
            if bool_parser_error:
                record_exception(balacne_exception_map, "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            else:
                record_exception(balacne_exception_map, "get_md_message_detail_error_num")  # 记录获取mq的message的详情信息失败个数
            continue
        # 解析当前json
        json_message_body_object = common.ParseJsonData(str_message_body)
        if len(json_message_body_object) == 0:
            error_message = "MQ解析messageBody为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        # 提取关键数据
        message_body_object = json_message_body_object["NonMotorVehicleObject"][0]
        if message_body_object == "":
            error_message = "MQ解析NonMotorVehicleObject为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        info_message = "MQ解析NonMotorVehicleObject成功，MQ返回的数据信息：%s" % (json_message_body_object)
        common.Log(info_message)
        # 获取公共信息，用来日志输出
        GetCommonInfoObjects(message_body_object)
        # 校验大图数据是否存在
        if False == IsContainsBigPicInfo(message_body_object, "nonmotor"):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的大图数据为空" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "large_image_missing_num")  # 大图缺失失败个数
        # 校验小图数据是否存在
        if IsSamllPicCheakFalg():  # 需要校验小图
            if False == IsContainsSmallPicInfo(message_body_object, "nonmotor"):
                error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的小图数据为空" % (
                global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
                common.Log(error_message)
                record_exception(balacne_exception_map,
                                "small_image_missing_num")  # 小图缺失失败个数
        # 校验是否存在features字段
        if True == IsContainsFeaturesInfo(message_body_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的存在Features字段" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "features_contains_num")  # 存在Features字段
        # 校验坐标是否存在
        if False == IsContaisCoordinate(message_body_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的小图坐标为空" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map, "coordinate_missing_num")  # 坐标缺失
            continue
        # 校验坐标格式是否正确
        if False == IsPixelCoordinate(message_body_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的坐标格式错误" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "coordinate_format_error_num")  # 坐标不是像素坐标

    return bool_check_result

#人体数据校验
def CheckPersonBalanceStkData(balacne_exception_map):
    bool_check_result = True
    # 主题名称
    topicName = "PERSON_BALANCE_STK"
    json_arr_group = GetBalanceMqMessage(topicName)
    group_arr_length = len(json_arr_group)
    # 如果数据为0，结束运行
    if 0 == group_arr_length:
        bool_check_result = False
        error_message = "MQ人体数据获取失败"
        common.Log(error_message)
        return bool_check_result
    # 增加数据限制
    if group_arr_length > 200:
        group_arr_length = 200

    for index in range(group_arr_length):
        record_exception(balacne_exception_map, "total_num")  # 记录巡检数据量
        curren_json_object = json_arr_group[index]
        str_msgId = curren_json_object["msgId"]
        # 获取数据详情
        str_message_body, bool_parser_error = GetBalanceMqMessageDetail(topicName, str_msgId)
        if str_message_body == "":
            if bool_parser_error:
                record_exception(balacne_exception_map, "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            else:
                record_exception(balacne_exception_map, "get_md_message_detail_error_num")  # 记录获取mq的message的详情信息失败个数
            continue
        # 解析当前json
        json_message_body_object = common.ParseJsonData(str_message_body)
        if len(json_message_body_object) == 0:
            error_message = "MQ解析messageBody为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        # 提取关键数据
        message_body_object = json_message_body_object["PersonObject"][0]
        if message_body_object == "":
            error_message = "MQ解析PersonObject为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        info_message = "MQ解析PersonObject成功，MQ返回的数据信息：%s" % (json_message_body_object)
        common.Log(info_message)
        # 获取公共信息，用来日志输出
        GetCommonInfoObjects(message_body_object)
        # 校验大图数据是否存在
        if False == IsContainsBigPicInfo(message_body_object, "person"):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的大图数据为空" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "large_image_missing_num")  # 大图缺失失败个数
        # 校验小图数据是否存在
        if IsSamllPicCheakFalg():  # 需要校验小图
            if False == IsContainsSmallPicInfo(message_body_object, "person"):
                error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的小图数据为空" % (
                global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
                common.Log(error_message)
                record_exception(balacne_exception_map,
                                 "small_image_missing_num")  # 小图缺失失败个数
        # 校验是否存在features字段
        if True == IsContainsFeaturesInfo(message_body_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的存在Features字段" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "features_contains_num")  # 存在Features字段
        # 校验坐标是否存在
        if False == IsContaisCoordinate(message_body_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的小图坐标为空" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map, "coordinate_missing_num")  # 坐标缺失
            continue
        # 校验坐标格式是否正确
        if False == IsPixelCoordinate(message_body_object):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的坐标格式错误" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "coordinate_format_error_num")  # 坐标不是像素坐标

    return bool_check_result

#全结构化数据校验
def CheckAllStructBalanceStkData(balacne_exception_map):
    bool_check_result = True
    # 主题名称
    topicName = "ALLSTRUCT_BALANCE_STK"
    json_arr_group = GetBalanceMqMessage(topicName)
    group_arr_length = len(json_arr_group)
    # 如果数据为0，结束运行
    if 0 == group_arr_length:
        bool_check_result = False
        error_message = "MQ全结构化数据获取失败"
        common.Log(error_message)
        return bool_check_result
    # 增加数据限制
    if group_arr_length > 200:
        group_arr_length = 200

    for index in range(group_arr_length):
        record_exception(balacne_exception_map, "total_num")  # 记录巡检数据量
        curren_json_object = json_arr_group[index]
        str_msgId = curren_json_object["msgId"]
        # 获取数据详情
        str_message_body, bool_parser_error = GetBalanceMqMessageDetail(topicName, str_msgId)
        if str_message_body == "":
            if bool_parser_error:
                record_exception(balacne_exception_map, "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            else:
                record_exception(balacne_exception_map, "get_md_message_detail_error_num")  # 记录获取mq的message的详情信息失败个数
            continue
        # 解析当前json
        json_message_body_object = common.ParseJsonData(str_message_body)
        if len(json_message_body_object) == 0:
            error_message = "MQ解析messageBody为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        # 提取关键数据
        extracted_key = ""
        if "FaceObject" in json_message_body_object and json_message_body_object["FaceObject"]:
            message_body_object = json_message_body_object["FaceObject"][0]
            extracted_key = "face"
        elif "PersonObject" in json_message_body_object and json_message_body_object["PersonObject"]:
            message_body_object = json_message_body_object["PersonObject"][0]
            extracted_key = "person"
        elif "NonMotorVehicleObject" in json_message_body_object and json_message_body_object["NonMotorVehicleObject"]:
            message_body_object = json_message_body_object["NonMotorVehicleObject"][0]
            extracted_key = "nonmotor"
        elif "MotorVehicleObject" in json_message_body_object and json_message_body_object["MotorVehicleObject"]:
            message_body_object = json_message_body_object["MotorVehicleObject"][0]
            extracted_key = "vehicle"
        if message_body_object == "":
            error_message = "MQ解析Allstruct的目标信息为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        info_message = "MQ解析Allstruct的Object成功，MQ返回的数据信息：%s" % (json_message_body_object)
        common.Log(info_message)
        # 获取公共信息，用来日志输出
        GetCommonInfoObjects(message_body_object)
        # 校验大图数据是否存在
        if False == IsContainsBigPicInfo(message_body_object, extracted_key):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的大图数据为空" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "large_image_missing_num")  # 大图缺失失败个数

    return bool_check_result

#人脸数据校验
def CheckFaceBalanceStkData(balacne_exception_map):
    bool_check_result = True
    # 主题名称
    topicName = "FACE_BALANCE_STK"
    json_arr_group = GetBalanceMqMessage(topicName)
    group_arr_length = len(json_arr_group)
    # 如果数据为0，结束运行
    if 0 == group_arr_length:
        bool_check_result = False
        error_message = "MQ人脸数据获取失败"
        common.Log(error_message)
        return bool_check_result
    # 增加数据限制
    if group_arr_length > 200:
        group_arr_length = 200

    for index in range(group_arr_length):
        record_exception(balacne_exception_map, "total_num")  # 记录巡检数据量
        curren_json_object = json_arr_group[index]
        str_msgId = curren_json_object["msgId"]
        # 获取数据详情
        str_message_body, bool_parser_error = GetBalanceMqMessageDetail(topicName, str_msgId)
        if str_message_body == "":
            if bool_parser_error:
                record_exception(balacne_exception_map, "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            else:
                record_exception(balacne_exception_map, "get_md_message_detail_error_num")  # 记录获取mq的message的详情信息失败个数
            continue
        # 解析当前json
        json_message_body_object = common.ParseJsonData(str_message_body)
        if len(json_message_body_object) == 0:
            error_message = "MQ解析messageBody为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        # 提取关键数据
        message_body_object = json_message_body_object["FaceObject"][0]
        if message_body_object == "":
            error_message = "MQ解析FaceObject为空，MQ返回的数据信息：%s" % (json_message_body_object)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "parser_md_message_detail_error_num")  # 解析mq的message的详情信息失败个数
            continue
        info_message = "MQ解析FaceObject成功，MQ返回的数据信息：%s" % (json_message_body_object)
        common.Log(info_message)
        # 获取公共信息，用来日志输出
        GetCommonInfoObjects(message_body_object)
        # 校验大图数据是否存在
        if False == IsContainsBigPicInfo(message_body_object, "face"):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的大图数据为空" % (
            global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "large_image_missing_num")  # 大图缺失失败个数
        # 校验小图数据是否存在
        if False == IsContainsSmallPicInfo(message_body_object, "face"):
            error_message = "相机编码【%s】卡口编码【%s】任务id【%s】数据ID【%s】的mq的小图数据为空" % (
                global_pic_CamCode, global_pic_TollgateCode, global_pic_task_id, global_pic_record_id)
            common.Log(error_message)
            record_exception(balacne_exception_map,
                             "small_image_missing_num")  # 小图缺失失败个数

    return bool_check_result

# 函数：生成单个异常字典的汇总字符串
def generate_exception_summary(exception_map,str_topic_name):
    result_message=""
    str_ret = "INFO"
    if len(exception_map) == 0:
        result_message = "主题【%s】，获取数据为空" % (str_topic_name)
        return str_ret,result_message
    #等级判断
    #判断是否是error等级
    for exception_type, count in exception_map.items():
        if exception_type != "total_num" and exception_type != "get_md_message_detail_error_num" and exception_type != "parser_md_message_detail_error_num":
            if 0 < count:
                str_ret = "ERROR"
                break
    #判断是否是warning等级
    if "INFO" == str_ret:
        for exception_type, count in exception_map.items():
            if exception_type == "get_md_message_detail_error_num" or exception_type == "parser_md_message_detail_error_num":
                if 0 < count:
                    str_ret = "WARNING"
                    break
    if "INFO" == str_ret:
        result_message = "主题【%s】，%s:%s,正常" % (str_topic_name, EXCEPTION_TYPES["total_num"],exception_map["total_num"])
        return str_ret, result_message
    #汇总结果
    summary_parts = []
    for exception_type, count in exception_map.items():
        # 格式化字符串
        summary_part = "{}: {}".format(EXCEPTION_TYPES[exception_type], count)
        # 添加到列表中
        summary_parts.append(summary_part)
    # 将所有部分用逗号隔开
    summary_message=", ".join(summary_parts)
    #汇总
    result_message = "主题【%s】，%s" % (str_topic_name,summary_message)
    return str_ret,result_message

def generate_exception_total_summary(vehicleCheckResult, nonvehicleCheckResult, personCheckResult, faceCheckResult,allstructCheckResult):
    str_level1 = "INFO"
    person_summary = ""

    str_level2 = "INFO"
    vehicle_summary = ""
    
    str_level3 = "INFO"
    nonmontor_summary = ""
    
    str_level4 = "INFO"
    face_summary = ""

    str_level5 = "INFO"
    allstruct_summary = ""

    if vehicleCheckResult == False:
        str_level1 = "WARNING"
        vehicle_summary = "MQ机动车数据格式检查失败"
    else:
        str_level1, vehicle_summary = generate_exception_summary(global_vehicle_balacne_exception_map,"VEHICLE_BALANCE_STK")

    if nonvehicleCheckResult == False:
        str_level2 = "WARNING"
        person_summary = "MQ人体数据格式检查失败"
    else:
        str_level2, person_summary = generate_exception_summary(global_person_balacne_exception_map,"PERSON_BALANCE_STK")

    if personCheckResult == False:
        str_level3 = "WARNING"
        nonmontor_summary = "MQ非机动车数据格式检查失败"
    else:
        str_level3, nonmontor_summary = generate_exception_summary(global_nonmontor_balacne_exception_map,"NONMOTOR_BALANCE_STK")

    if faceCheckResult == False:
        str_level4 = "WARNING"
        face_summary = "MQ人脸数据格式检查失败"
    else:
        str_level4, face_summary = generate_exception_summary(global_face_balacne_exception_map,"FACE_BALANCE_STK")

    if allstructCheckResult == False:
        str_level5 = "WARNING"
        allstruct_summary = "MQ的allstruct数据格式检查失败"
    else:
        str_level5, allstruct_summary = generate_exception_summary(global_allstruct_balacne_exception_map, "ALLSTRUCT_BALANCE_STK")

    # 汇总所有异常字典的结果，用分号隔开
    overall_summary = "; ".join([
        vehicle_summary,
        person_summary,
        nonmontor_summary,
        face_summary,
        allstruct_summary
    ])
    print overall_summary

    if str_level1 == "ERROR" or str_level2 == "ERROR" or str_level3 == "ERROR" or str_level4 == "ERROR" or str_level5 == "ERROR":
        sys.exit(common.EXIT_STATUS_ERROR)
    elif str_level1 == "WARNING" or str_level2 == "WARNING" or str_level3 == "WARNING" or str_level4 == "WARNING" or str_level5 == "WARNING":
        sys.exit(common.EXIT_STATUS_WARNING)
    else:
        sys.exit(common.EXIT_STATUS_INFO)

# 校验各个主题数据
vehicleCheckResult = CheckVehicleBalanceStkData(global_vehicle_balacne_exception_map)
nonvehicleCheckResult = CheckNonmotorBalanceStkData(global_nonmontor_balacne_exception_map)
personCheckResult = CheckPersonBalanceStkData(global_person_balacne_exception_map)
faceCheckResult = CheckFaceBalanceStkData(global_face_balacne_exception_map)
allstructCheckResult = CheckAllStructBalanceStkData(global_allstruct_balacne_exception_map)

#汇总结果
generate_exception_total_summary(vehicleCheckResult, nonvehicleCheckResult, personCheckResult, faceCheckResult, allstructCheckResult)


