﻿import sys
import common
import datetime
from datetime import datetime, timedelta

PG_PASSWD = ""
PG_PORT = common.GetIamPgPort()
# as(全量解析) MQ日均接入数据量（通过数据统计模块统计）
def AsDataCountFromMq(str_date) :
    sql = ''''''
    as_data_count = 0
    as_select_result = ""
    sql = '''
        SELECT  
            COALESCE(SUM(stage_num),0)
        FROM
            public.tbl_ia_count_statistics 
        WHERE
            start_time BETWEEN '%sT00:00:00' AND '%sT23:59:59' 
            AND ((item_name='from_mq_balance' AND item_type=504 AND task_id='ALL' AND work_mode=300)
                OR (item_name='from_mq_balance_face' AND item_type=900 AND work_mode=903)
            )
    ''' % (str_date, str_date)
    b_search_status, as_select_result = common.PorcessPgSqlCommand("ias", "postgres", "127.0.0.1", PG_PORT, PG_PASSWD, sql)
    as_data_count = as_select_result.strip()
    return b_search_status, as_data_count

# fs MQ日均接入数据量（通过数据统计模块统计）
def FsDataCountFromMq(str_date) :
    sql = ''''''
    fs_data_count = 0
    fs_select_result = ""
    b_search_status = False
    if common.IsSupportKanbanCheckMode() == False:
        sql = '''
            SELECT 
                COALESCE(SUM(stage_num),0) 
            FROM 
                public.tbl_ia_count_statistics 
            WHERE 
                start_time BETWEEN '%sT00:00:00' AND '%sT23:59:59' 
                AND work_mode=300 
                AND item_name='mq_consumer_count'
                AND item_type=300
                AND task_id='ALL';
        '''% (str_date, str_date)
        b_search_status, fs_select_result = common.PorcessPgSqlCommand("ias", "postgres", "127.0.0.1", PG_PORT, PG_PASSWD, sql)
    else :
        sql = '''
            SELECT
                COALESCE(SUM(stage_num),0)
            FROM
                public.tbl_ia_count_statistics 
            WHERE
                start_time BETWEEN '%sT00:00:00' AND '%sT23:59:59' 
                AND ((item_name='from_mq_balance' AND item_type=504 AND task_id='ALL' AND work_mode=300)
                    OR (item_name='from_mq_balance_face' AND item_type=900 AND work_mode=903)
                )
        ''' % (str_date, str_date)
        b_search_status, fs_select_result = common.PorcessPgSqlCommand("ias", "postgres", "127.0.0.1", PG_PORT, PG_PASSWD, sql)
    fs_data_count = fs_select_result.strip()
    return b_search_status, fs_data_count


### vas MQ日均接入数据量（通过数据统计模块统计）
### @param stt_date 统计日期，格式XXXX-XX-XX
def VasDataCountFromMq(str_date) :
    sql = ''''''
    vas_data_count = 0
    vas_select_result = "";
    b_search_status = False
    if common.IsSupportKanbanCheckMode() == False:
        sql = '''
            SELECT 
                COALESCE(SUM(stage_num),0) 
            FROM 
                public.tbl_ia_count_statistics 
            WHERE 
                start_time BETWEEN '%sT00:00:00' AND '%sT23:59:59' 
                AND work_mode=103 
                AND task_id='ALL'
                AND item_type=0
                AND item_name='mq_consumer_count';
        '''% (str_date, str_date)
        b_search_status, vas_select_result = common.PorcessPgSqlCommand("ias", "postgres", "127.0.0.1", PG_PORT, PG_PASSWD, sql)
    else :
        sql = '''
            SELECT
                COALESCE(SUM(stage_num),0)
            FROM
                public.tbl_ia_count_statistics 
            WHERE
                start_time BETWEEN '%sT00:00:00' AND '%sT23:59:59' 
                AND ((item_name='from_mq_balance' AND item_type=500 AND task_id='ALL')
                    OR (item_name='from_mq_balance_nonmotor' OR item_name='from_mq_balance_person' OR item_name='from_mq_balance_vehicle' AND item_type=900 AND work_mode=903)
                )
        ''' % (str_date, str_date)
        b_search_status, vas_select_result = common.PorcessPgSqlCommand("ias", "postgres", "127.0.0.1", PG_PORT, PG_PASSWD, sql)
    vas_data_count = vas_select_result.strip()
    return b_search_status, vas_data_count

# MQ日均数据量检查
def MqDataCountCheck() : 
    if common.IsSupportDataStatistics() == False : 
        # 如果不支持数据统计模块，则无法检查该
        error_message = "iam不支持数据统计检查"
        sys.exit(common.EXIT_STATUS_WARNING)
    
    # 解析脚本传参（数据库密码）
    if len(sys.argv) < 2:
        common.Log(sys.argv[0])
        print "MQ日均接入数据量统计检查失败，传参异常，参数列表长度：%d" % (len(sys.argv))
        sys.exit(common.EXIT_STATUS_WARNING)
    global PG_PASSWD
    PG_PASSWD = sys.argv[1]# 获取当前日期和时间
    now = datetime.now()
    # 计算前一天的日期
    yesterday = now - timedelta(days=1)
    # 格式化日期为 XXXX-XX-XX
    formatted_yesterday = yesterday.strftime('%Y-%m-%d')
    
    # vas日均数据量检查
    vas_error_message = ""
    fs_error_message = ""
    as_error_message = ""
    b_vas_search_status, vas_data_count_from_mq = VasDataCountFromMq(formatted_yesterday)
    if False == b_vas_search_status:
        common.Log("vas statistics sql process error")
        vas_error_message = "vas 数据统计检查失败。"
    else :
        if len(vas_data_count_from_mq) == 0:
            vas_data_count_from_mq = 0
        vas_error_message = "%s 接入机非人数据量：%s。" % (formatted_yesterday, vas_data_count_from_mq)
         
    # fs日均数据量检查
    b_fs_search_status, fs_data_count_from_mq = FsDataCountFromMq(formatted_yesterday)
    if False == b_fs_search_status:
        common.Log("fs statistics sql process error")
        fs_error_message = "fs 数据统计检查失败。"
    else :
        if len(fs_data_count_from_mq) == 0:
            fs_data_count_from_mq = 0
        fs_error_message = "%s 接入人脸数据量：%s。" % (formatted_yesterday, fs_data_count_from_mq)
         
    # AS全量解析数据检查
    b_as_search_status, as_data_count_from_mq = AsDataCountFromMq(formatted_yesterday)
    if False == b_as_search_status:
        common.Log("as statistics sql process error")
        as_error_message = "as 数据统计检查失败。"
    else :
        if len(as_data_count_from_mq) == 0:
            as_data_count_from_mq = 0
        as_error_message = "%s 接入全量解析数据量：%s。" % (formatted_yesterday, as_data_count_from_mq)
    error_message = "%s%s%s" % (vas_error_message, fs_error_message, as_error_message)
    print error_message
    sys.exit(common.EXIT_STATUS_INFO)
    
MqDataCountCheck()