﻿import sys
import json
import common

DATA_DELAY_LIMIT=1000

def CheckMqDataDelay():
    error_message = ""
    md_ip = common.GetMdIp()
    url="http://%s:8050/consumer/groupList.query" % (common.GetUtf8Str(md_ip))
    common.Log("即将访问URL：%s" % (url))
    person_group="C_PERSON_STK_IA12500-VAS_f_PIC"
    nonmotor_group="C_NONMOTOR_STK_IA12500-VAS_f_PIC"
    vehicle_group="C_VEHICLE_STK_IA12500-VAS_f_PIC"
    face_group="IA_FACE_BALANCE_STK_"
    allstruct_group="C_ALLSTRUCT_STK_IA12500-VAS_f_PIC"
    # 访问MQ数据
    json_result = common.GetDataFromUrl(url)
    # 解析MQ返回的结果
    json_object = common.ParseJsonData(json_result)
    if 0 == len(json_object) :
        error_message = "MQ数据积压检查失败，MQ返回的数据信息：%s" % (common.GetUtf8Str(json_object))
        print error_message
        sys.exit(common.EXIT_STATUS_WARNING)
    
    json_arr_group = json_object["data"]
    group_arr_length=len(json_arr_group)
    # 如果数据为0，结束运行
    if 0 == group_arr_length :
        error_message = "MQ数据积压检查失败，MQ返回的数据信息：%s" % (common.GetUtf8Str(json_object))
        print error_message
        sys.exit(common.EXIT_STATUS_WARNING)
    for index in range(group_arr_length) : 
        curren_json_object = json_arr_group[index]
        group_name = common.GetUnicodeStr(curren_json_object["group"])
        int_current_delay = curren_json_object["diffTotal"]
        int_current_tps = curren_json_object["consumeTps"]
        log_message = "GroupName: %s 数据积压：%d 当前分析速度：%d" % (common.GetUtf8Str(group_name), int_current_delay, int_current_tps)
        if common.GetUnicodeStr(person_group) == group_name : 
            common.Log(log_message)
            if int_current_delay > DATA_DELAY_LIMIT :
                error_message = "%s，人体数据已积压：%d" % (error_message, int_current_delay)
                log_message = "%s，消费速度：%d" % (error_message,int_current_tps)
                common.Log(log_message)
        elif common.GetUnicodeStr(nonmotor_group) == group_name : 
            common.Log(log_message)
            if int_current_delay > DATA_DELAY_LIMIT :
                error_message = "%s，非机动车数据已积压：%d" % (error_message, int_current_delay)
                log_message = "%s，消费速度：%d" % (error_message,int_current_tps)
                common.Log(log_message)
        elif common.GetUnicodeStr(vehicle_group) == group_name : 
            common.Log(log_message)
            if int_current_delay > DATA_DELAY_LIMIT :
                error_message = "%s，机动车数据已积压：%d" % (error_message, int_current_delay)
                log_message = "%s，消费速度：%d" % (error_message,int_current_tps)
                common.Log(log_message)
        elif common.GetUnicodeStr(face_group) == group_name : 
            common.Log(log_message)
            if int_current_delay > DATA_DELAY_LIMIT :
                error_message = "%s，人脸数据已积压：%d" % (error_message, int_current_delay)
                log_message = "%s，消费速度：%d" % (error_message,int_current_tps)
                common.Log(log_message)
        elif common.GetUnicodeStr(allstruct_group) == group_name :  
            common.Log(log_message)
            if int_current_delay > DATA_DELAY_LIMIT : 
                error_message = "%s，全量解析数据已积压：%d" % (error_message, int_current_delay)
                log_message = "%s，消费速度：%d" % (error_message,int_current_tps)
                common.Log(log_message)
        else:
            log_message = "非智能消费者组：%s" % (common.GetUtf8Str(group_name))
            common.Log (log_message)
    if error_message == "" :
        print "MQ无数据积压"
        sys.exit(common.EXIT_STATUS_INFO)
    else :
        print error_message
        sys.exit(common.EXIT_STATUS_ERROR)

# 检查MQ数据堆积情况
CheckMqDataDelay()
