﻿import common
import time
import sys

MD_IP = common.GetMdIp()

# 检查最近1分钟内是否有数据更新
def MqDataUpdataCheck(str_topic) : 
    error_message = ""
    # 获取当前时间的秒级时间戳
    current_timestamp_seconds = time.time()
    begin_time_mill = int(current_timestamp_seconds * 1000)
    end_time_mill = int((current_timestamp_seconds+60*2) * 1000)
    # print "DEBUG %d    %d    %d" % (current_timestamp_seconds, begin_time_mill, end_time_mill)
    url = "http://%s:8050/message/queryMessageByTopic.query?begin=%d&end=%d&topic=%s" % (MD_IP, begin_time_mill, end_time_mill, str_topic)
    # print "DEBUG url: %s"url
    response_result = common.GetDataFromUrl(url)
    if response_result == "" or response_result is None :
        error_message = "数据更新检查失败"
        log_message = "%s，URL访问异常，URL：%s" % (error_message, url)
        print error_message
        sys.exit(common.EXIT_STATUS_WARNING)
    
    response_json = common.ParseJsonData(response_result)
    if response_json == "" or response_json is None :
        error_message = "数据更新检查失败"
        log_message = "%s，json解析失败" % (error_message)
        print error_message
        sys.exit(common.EXIT_STATUS_WARNING)
        
    data_arr = response_json["data"]
    if data_arr == "" or data_arr is None :
        error_message = "MQ中无该Topic：%s" % (str_topic) 
    elif len(data_arr) == 0 :
        error_message = "%s近一分钟内无数据更新" % (str_topic) 
    return error_message

def MainCheck() :
    error_message = ""
    
    # 人体数据更新检查
    perosn_balance_message = MqDataUpdataCheck("PERSON_BALANCE_STK")
    if perosn_balance_message != "" :
        error_message = perosn_balance_message
    else :
        person_stkex_message = MqDataUpdataCheck("PERSON_STKEX")
        if person_stkex_message != "" :
            error_message = "%s，%s" % (error_message, person_stkex_message)
    
    # 机动车数据更新检查
    vehicle_balance_message = MqDataUpdataCheck("VEHICLE_BALANCE_STK")
    if vehicle_balance_message != "" :
        error_message = "%s，%s" % (error_message, vehicle_balance_message)
    else :
        vehicle_stkex_message = MqDataUpdataCheck("VEHICLE_STKEX")
        if vehicle_stkex_message != "" :
            error_message = "%s，%s" % (error_message, vehicle_stkex_message)        
    
    # 非机动车数据更新检查
    nonmotor_balance_message = MqDataUpdataCheck("NONMOTOR_BALANCE_STK")
    if nonmotor_balance_message != "" :
        error_message = "%s，%s" % (error_message, nonmotor_balance_message)
    else:
        nonmotor_stkex_message = MqDataUpdataCheck("NONMOTOR_STKEX")
        if nonmotor_stkex_message != "" :
            error_message = "%s，%s" % (error_message, nonmotor_stkex_message)      
    
    # 人脸数据更新检查
    face_balance_message = MqDataUpdataCheck("FACE_BALANCE_STK")
    if face_balance_message != "" :
        error_message = "%s，%s" % (error_message, face_balance_message)
    else :
        face_stkex_message = MqDataUpdataCheck("FACE_STKEX")
        if face_stkex_message != "" :
            error_message = "%s，%s" % (error_message, face_stkex_message)
     
    # 全量解析数据更新检查
    allstruct_balance_message = MqDataUpdataCheck("ALLSTRUCT_BALANCE_STK")
    if allstruct_balance_message != "" :
        error_message = "%s，%s" % (error_message, allstruct_balance_message)
    else :
        person_stkex_message = MqDataUpdataCheck("PERSON_STKEX")
        if person_stkex_message != "" :
            error_message = "%s，%s" % (error_message, person_stkex_message)
            
        vehicle_stkex_message = MqDataUpdataCheck("VEHICLE_STKEX")
        if vehicle_stkex_message != "" :
            error_message = "%s，%s" % (error_message, vehicle_stkex_message)
        
        nonmotor_stkex_message = MqDataUpdataCheck("NONMOTOR_STKEX")
        if nonmotor_stkex_message != "" :
            error_message = "%s，%s" % (error_message, nonmotor_stkex_message)
        
        face_stkex_message = MqDataUpdataCheck("FACE_STKEX")
        if face_stkex_message != "" :
            error_message = "%s，%s" % (error_message, face_stkex_message)
     
    # 如果第一个字符是中文逗号，则删除它
    if common.GetUnicodeStr(error_message)[0] == common.GetUnicodeStr("，") :
        error_message = common.GetUnicodeStr(error_message)[1:]
    
    #返回数据更新检查结果
    if error_message == "" :
        print "数据更新正常"
        sys.exit(common.EXIT_STATUS_INFO)
    else :
        print error_message
        sys.exit(common.EXIT_STATUS_WARNING)

MainCheck()