﻿# 判断当前的mq的数据是否存在分析异常，导致的stk->balanace_stk->stk_ex的数量不一致
import sys
import common
import time
from collections import namedtuple
from datetime import datetime, timedelta
import os
import subprocess
import platform

global_db_name = 'ias'
global_db_user = 'postgres'
global_db_password = 'Zhineng_1'
global_db_host = '206.206.124.31'
global_db_port = common.GetIamPgPort()
global_bool_check_face_falg = False #param 6: 是否巡检人脸业务
global_bool_check_vas_falg = False #param 7: 是否巡检结构化业务 103
global_bool_check_as_second_falg = False #param 8: 是否巡检全结构化二次解析业务  903
global_bool_check_as_all_falg = False #param 9: 是否巡检全结构化全量解析业务 901
# 获取当前日期
today = datetime.today()
global_start_time_today = datetime(today.year, today.month, today.day-1, 0, 0, 0).strftime('%Y-%m-%d %H:%M:%S')
global_end_time_today = datetime(today.year, today.month, today.day+1, 23, 59, 59).strftime('%Y-%m-%d %H:%M:%S')

# 定义统计结构体
#无看板特性的结构体包含：mq消费的总数量、推入算法的数量、算法回调总数量、算法分析失败数量
#注意：推入算法的数量的数量指的是调用推帧接口的次数。包含推入失败的数量。
NoKanbanVasStatStruct = namedtuple('NoKanbanVasStatStruct', ['form_mq_num', 'push_algo_num', 'callback_form_algo_num', 'algo_callback_fail_count'])

# 定义有数据看板的结构体
# 有看板特性的结构体包含：mq消费的总数量、推入算法的数量、算法回调总数量、算法分析失败数量、回写stk_ex的数据
KanbanCommonStatStruct = namedtuple('KanbanCommonStatStruct', ['form_mq_num', 'push_algo_num', 'callback_form_algo_num', 'algo_callback_fail_count', 'push_stkex_count'])

# 判断是否存在统计功能，并判断是否巡检
def IsSupportLossDataCheck():
    bool_support_check = False
    ret_message=""
    try:
        # 定义要执行的命令
        command1 = ['iamcfg', 'list']
        command2 = ['grep Statistics-Report-Switch']
        # 获取配置项
        proc1 = subprocess.Popen(command1, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        proc2 = subprocess.Popen(command2, stdin=proc1.stdout, stdout=subprocess.PIPE, stderr=subprocess.PIPE,shell=True)
        proc1.stdout.close()
        output2, error2  = proc2.communicate()  # 等待命令执行完成并获取输出
        info_message = "iam获取的Statistics-Report-Switch配置项信息为[%s]" % (output2)
        common.Log(info_message)
        if output2:
            # 解析配置项
            split_list = output2.split()
            if 2 <= len(split_list) :
                str_value = split_list[2]
                if str_value == "1" :
                    bool_support_check = True
                else:
                    info_message = "iam获取的Statistics-Report-Switch配置项值为[%s]，请调整后再次巡检" % (str_value)
                    common.Log(info_message)
                    ret_message = info_message
        if error2:
            bool_support_check = False
            error_message = "iam获取的Statistics-Report-Switch配置项失败，错误信息：【%s】" % (error2)
            common.Log(error_message)
            ret_message = error_message

    except Exception as e:
        bool_support_check = False
        error_message = "IsSupportLossDataCheck Exception occurred: %s" % str(e)
        common.Log(error_message)
        ret_message = error_message
    return bool_support_check,ret_message

# 判断巡检模式，是否板特性和非看板特性两种
def IsSupportKanbanCheckMode():
    bool_support_kanban = False
    try:
        # 定义要执行的命令
        command1 = ['iamcfg', 'list']
        command2 = ['grep Statistics-Report-Quickly']
        # 获取配置项
        proc1 = subprocess.Popen(command1, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        proc2 = subprocess.Popen(command2, stdin=proc1.stdout, stdout=subprocess.PIPE, stderr=subprocess.PIPE,shell=True)
        proc1.stdout.close()
        output2, error2 = proc2.communicate()  # 等待命令执行完成并获取输出
        info_message = "iam获取的Statistics-Report-Quickly配置项信息为[%s]" % (output2)
        common.Log(info_message)
        if output2: #不为空
            bool_support_kanban = True
        else:
            bool_support_kanban = False
    except Exception as e:
        bool_support_kanban = False
        error_message = "IsSupportKanbanCheckMode Exception occurred: %s" % str(e)
        common.Log(error_message)
    return bool_support_kanban

#生成无数据看板的人脸查询sql
#300：从mq消费的数量,308：推入算法的次数, 309：算法回调次数 ,310：算法分析失败个数,301:写入stk_ex数据
def GenerateNoKanbanModeFaceSql(start_time, end_time):
    sql_query = '''
        SELECT
            SUBSTRING(engine_id FROM 'engine-(.*?)#') AS engine_prefix,
            SUM(CASE WHEN item_type = 300 THEN total_num ELSE 0 END) AS total_num_1,  
            SUM(CASE WHEN item_type = 308 THEN total_num ELSE 0 END) AS total_num_2,
            SUM(CASE WHEN item_type = 309 THEN total_num ELSE 0 END) AS total_num_3,
            SUM(CASE WHEN item_type = 310 THEN total_num ELSE 0 END) AS total_num_4,
            SUM(CASE WHEN item_type = 301 THEN total_num ELSE 0 END) AS total_num_5
        FROM
            public.tbl_ia_count_statistics
        WHERE
            start_time >= '{start_time}' AND
            end_time <= '{end_time}' AND
            engine_id <> 'ALL' AND
            work_mode BETWEEN 300 AND 303
        GROUP BY
            SUBSTRING(engine_id FROM 'engine-(.*?)#');
        '''.format(start_time=start_time, end_time=end_time)
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    return sql_query_single_line

#生成无数据看板的VAS查询sql
#0：从mq消费的数量,1：推入算法的次数, 2：算法回调次数 ,3：算法分析失败个数,
def GenerateNoKanbanModeVasSql(start_time, end_time):
    sql_query = '''
        SELECT
            SUBSTRING(engine_id FROM 'engine-(.*?)#') AS engine_prefix,
            SUM(CASE WHEN item_type = 0 THEN total_num ELSE 0 END) AS total_num_1,  
            SUM(CASE WHEN item_type = 1 THEN total_num ELSE 0 END) AS total_num_2,
            SUM(CASE WHEN item_type = 2 THEN total_num ELSE 0 END) AS total_num_3,
            SUM(CASE WHEN item_type = 3 THEN total_num ELSE 0 END) AS total_num_4
        FROM
            public.tbl_ia_count_statistics
        WHERE
            start_time >= '{start_time}' AND
            end_time <= '{end_time}' AND
            engine_id <> 'ALL' AND
            work_mode = 103
        GROUP BY
            SUBSTRING(engine_id FROM 'engine-(.*?)#');
        '''.format(start_time=start_time, end_time=end_time)
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    return sql_query_single_line

#生成有数据看板的人脸查询sql
#504：mq消费的数量,308：推入算法的次数, 309：算法回调次数 ,310：算法分析失败个数,505:回写mq的数据量
def GenerateKanbanModeFaceSql(start_time, end_time):
    sql_query = '''
        SELECT
            SUBSTRING(engine_id FROM 'engine-(.*?)#') AS engine_prefix,
            SUM(CASE WHEN item_name = 'from_mq_balance' THEN total_num ELSE 0 END) AS total_num_1,  
            SUM(CASE WHEN item_name = 'push_to_algo_count' THEN total_num ELSE 0 END) AS total_num_2,
            SUM(CASE WHEN item_name = 'callback_from_algo_count' THEN total_num ELSE 0 END) AS total_num_3,
            SUM(CASE WHEN item_name = 'algo_callback_fail_count' THEN total_num ELSE 0 END) AS total_num_4,
            SUM(CASE WHEN item_name = 'to_mq_stkex' THEN total_num ELSE 0 END) AS total_num_5
        FROM
            public.tbl_ia_count_statistics
        WHERE
            start_time >= '{start_time}' AND
            end_time <= '{end_time}' AND
            engine_id <> 'ALL' AND
            work_mode BETWEEN 300 AND 303
        GROUP BY
            SUBSTRING(engine_id FROM 'engine-(.*?)#');
        '''.format(start_time=start_time, end_time=end_time)
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    return sql_query_single_line

#生成有数据看板的VAS查询sql
#500：从mq消费的数量,1：推入算法的次数, 2：算法回调次数 ,3：算法分析失败个数,501：回写stk_ex的数量
#由于不同的业务枚举不同，修改成用统计项的名称进行区分
#work_mode 103:结构化图片流  903：全结构化二次解析  901：全量解析
def GenerateKanbanModeVasAndAsSql(start_time, end_time,work_mode):
    sql_query = '''
        SELECT
            SUBSTRING(engine_id FROM 'engine-(.*?)#') AS engine_prefix,
            SUM(CASE WHEN item_name = 'from_mq_balance_person' OR item_name = 'from_mq_balance_nonmotor' OR item_name = 'from_mq_balance_vehicle' OR item_name = 'from_mq_balance_face' OR item_name = 'from_mq_balance_allstruct' THEN total_num ELSE 0 END) AS total_num_1,  
            SUM(CASE WHEN item_name = 'push_to_algo_count' THEN total_num ELSE 0 END) AS total_num_2,
            SUM(CASE WHEN item_name = 'callback_from_algo_count' THEN total_num ELSE 0 END) AS total_num_3,
            SUM(CASE WHEN item_name = 'algo_analyse_fail_count' THEN total_num ELSE 0 END) AS total_num_4,
            SUM(CASE WHEN item_name = 'to_mq_stkex_person' OR item_name = 'to_mq_stkex_nonmotor' OR item_name = 'to_mq_stkex_vehicle' OR item_name = 'to_mq_stkex_face' THEN total_num ELSE 0 END) AS total_num_5
        FROM
            public.tbl_ia_count_statistics
        WHERE
            start_time >= '{start_time}' AND
            end_time <= '{end_time}' AND
            engine_id <> 'ALL' AND
            work_mode = {work_mode}
        GROUP BY
            SUBSTRING(engine_id FROM 'engine-(.*?)#');
        '''.format(start_time=start_time, end_time=end_time, work_mode=work_mode)
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    return sql_query_single_line

#根据sql的数据组织成对应的map返回,返回值带有写入stkex数据
def HandleSqlData(sql_data,bool_stk_ex_falg):
    if bool_stk_ex_falg:
        int_num_files = 6
        info_message = "字段属性长度为【%d】应包含引擎ID、mq消费的总数量、推入算法的数量、算法回调总数量、算法分析失败数量、回写stk_ex的数据" % (int_num_files)
        common.Log(info_message)
    else:
        int_num_files = 5
        info_message = "字段属性长度为【%d】应包含引擎ID、mq消费的总数量、推入算法的数量、算法回调总数量、算法分析失败数量" % (int_num_files)
        common.Log(info_message)
    #缓存结果，key表示引擎ID，value是结构体，包含给类数据的统计结果
    stats_map = {}
    #处理sql数据
    lines = sql_data.split('\r\n')
    for line in lines:
        if line != "":
            # 按|分割每一行，并去除每个元素前后的空格
            parts = [part.strip() for part in line.split('|')]
            if len(parts) != int_num_files:
                info_message = "通用sql的返回单行数据为：[%s]，字段个数为[%d]，与实际要求字段数[%d],不符合" % (line,len(parts),int_num_files)
                common.Log(info_message)
                continue
            engine_id = parts[0]
            fields_id = parts[1:]
            if bool_stk_ex_falg:
                # 使用 _make 方法将列表转换为 StatStruct 实例，并将 id 作为字典的键
                stats_map[engine_id] = KanbanCommonStatStruct._make(fields_id)
            else:
                # 使用 _make 方法将列表转换为 StatStruct 实例，并将 id 作为字典的键
                stats_map[engine_id] = NoKanbanVasStatStruct._make(fields_id)
    return stats_map

#计算比值和阈值进行
def check_ratio(num1, num2,threshold,less_falg):
    bool_error = False
    ratio = 0.0
    try:
        # 尝试将输入转换为整数
        int_num1 = int(num1)
        int_num2 = int(num2)
        # 检查除数是否为零
        if int_num2 == 0:
            info_message = "输入的值为【{}】,【{}】,除数不能为零".format(int_num1, int_num2)
            common.Log(info_message)
            return bool_error,ratio
        # 计算比值
        ratio = float(int_num1) / int_num2
        # 检查比值是否大于阈值
        if less_falg: #小于阈值提示
            if ratio <= threshold:
                bool_error = True
                info_message = "输入的值为【{}】,【{}】,计算后的值为：【{:.4f}],小于或等于阈值【{:.4f}】".format(
                    int_num1, int_num2, ratio, threshold)
            else:
                info_message = "输入的值为【{}】,【{}】,计算后的值为：【{:.4f}],大于或等于阈值【{:.4f}】".format(
                    int_num1, int_num2, ratio, threshold)
        else: #大于阈值提示
            if ratio >= threshold:
                bool_error = True
                info_message = "输入的值为【{}】,【{}】,计算后的值为：【{:.4f}],大于或等于阈值【{:.4f}】".format(
                    int_num1, int_num2, ratio, threshold)
            else:
                info_message = "输入的值为【{}】,【{}】,计算后的值为：【{:.4f}],小于或等于阈值【{:.4f}】".format(
                    int_num1, int_num2, ratio, threshold)
        common.Log(info_message)
    except ValueError as e:
        info_message = "输入的值为【{}】,【{}】,转换int出现异常【{}】".format(num1, num2, e)
        common.Log(info_message)
    except ZeroDivisionError as e:
        info_message = "输入的值为【{}】,【{}】,计算出现异常【{}】".format(num1, num2, e)
        common.Log(info_message)
    except Exception as e:
        info_message = "输入的值为【{}】,【{}】,出现异常【{}】".format(num1, num2, e)
        common.Log(info_message)
    return bool_error,ratio


#分析数据，alanyse_stk_ex_loss_falg是否启用分析stk_ex的数据丢失情况
def CheckSqlData(sql_data,alanyse_stk_ex_loss_falg):
    algo_analyze_fail_map = {} #记录算法分析失败的总数
    data_error_loss_map = {}   #记录数据格式不对，未推入算法的数量
    stk_ex_loss_map={} #记录回写stk_ex的数据丢失程度
    #重组数据结果
    stats_map = HandleSqlData(sql_data,alanyse_stk_ex_loss_falg)
    #记录引擎的总数
    engine_total_num = len(stats_map)
    #遍历结果并进行汇总数据
    for key, value in stats_map.items():
        #分析算法分析失败的百分比
        push_algo_num = value.push_algo_num #推入算法的数量
        algo_callback_fail_count = value.algo_callback_fail_count  #算法分析失败的数据
        bool_error, ratio = check_ratio(algo_callback_fail_count,push_algo_num,0.01,False)
        if bool_error:
            if key not in algo_analyze_fail_map:
                algo_analyze_fail_map[key] = ratio
                info_message = "引擎ID【{}】,算法分析失败的百分比【{}】，高于阈值【0.01】".format(key,ratio)
                common.Log(info_message)
            else:
                algo_analyze_fail_map[key] = ratio
                info_message = "引擎ID为【{}】,已记录算法分析失败数据,算法分析失败的百分比【{}】".format(key,ratio)
                common.Log(info_message)

        # 数据格式问题数据丢失百分比百分比
        push_algo_num = value.push_algo_num  # 推入算法的数量
        form_mq_num = value.form_mq_num  # 消费的mq数据
        bool_error, ratio = check_ratio(push_algo_num, form_mq_num, 0.95,True)
        if bool_error:
            if key not in data_error_loss_map:
                data_error_loss_map[key] = ratio
                info_message = "引擎ID【{}】,推入算法数量和从mq消费数据的百分比为【{}】，低于阈值【0.95】".format(key, ratio)
                common.Log(info_message)
            else:
                data_error_loss_map[key] = ratio
                info_message = "引擎ID为【{}】,已记录算法分析失败数据,,推入算法数量和从mq消费数据的百分比为【{}】".format(key, ratio)
                common.Log(info_message)
        if alanyse_stk_ex_loss_falg:
            # 记录回写stk_ex的数据丢失程度
            push_stkex_count = value.push_stkex_count  # 写入stk_ex的数据
            callback_form_algo_num = value.callback_form_algo_num  # 消费的mq数据
            bool_error, ratio = check_ratio(push_stkex_count, callback_form_algo_num, 0.98, True)
            if bool_error:
                if key not in stk_ex_loss_map:
                    stk_ex_loss_map[key] = ratio
                    info_message = "引擎ID【{}】,,分析写入ex的数量和callback_form_algo_num的百分比为【{}】，低于阈值阈值【0.98】".format(key, ratio)
                    common.Log(info_message)
                else:
                    stk_ex_loss_map[key] = ratio
                    info_message = "引擎ID为【{}】,已记录算法分析失败数据,分析写入ex的数量和callback_form_algo_num的百分比为【{}】".format(key, ratio)
                    common.Log(info_message)
    return engine_total_num,algo_analyze_fail_map,data_error_loss_map,stk_ex_loss_map

def GetCheckResult(str_sql,str_report_message,bool_analyse_set_ex):
    int_ret = common.EXIT_STATUS_INFO
    str_message = ""
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port, global_db_password, str_sql)
    if False == bool_ret:
        str_message = "获取统计数据失败,【{}】MQ数据丢失巡检失败".format(str_report_message)
        int_check_face_ret = common.EXIT_STATUS_WARNING
    else:
        if str_data:
            engine_total_num, algo_analyze_fail_map, data_error_loss_map, stk_ex_loss_map = CheckSqlData(str_data,bool_analyse_set_ex)
            # 生成结果
            if len(algo_analyze_fail_map) != 0 or len(data_error_loss_map) != 0 or len(stk_ex_loss_map) != 0:
                int_ret = common.EXIT_STATUS_ERROR
            str_message = "{}的MQ数据丢失巡检结果汇总：引擎总数【{}】，算法分析异常导致数据丢失的引擎个数【{}】，数据个数导致丢失的引擎个数【{}】，反写MQ数据异常的引擎个数【{}】".format(
                str_report_message,engine_total_num, len(algo_analyze_fail_map), len(data_error_loss_map), len(stk_ex_loss_map))
        else:
            str_message = "获取统计数据为空,{}MQ数据丢失巡检失败".format(str_report_message)
            int_check_face_ret = common.EXIT_STATUS_WARNING
    return int_ret,str_message
# 无看板特性的巡检
def CheckDataByNoKanbanMode():
    int_ret=common.EXIT_STATUS_INFO
    str_message=""
    #人脸业务巡检
    if global_bool_check_face_falg:
        # 组织sql
        str_sql=GenerateNoKanbanModeFaceSql(global_start_time_today,global_end_time_today)
        ret,message = GetCheckResult(str_sql,"无看板人脸业务",True)
        if ret > int_ret:
            int_ret = ret
        str_message += message
    #结构化业务
    if global_bool_check_vas_falg:
        # 组织sql
        str_sql=GenerateNoKanbanModeVasSql(global_start_time_today,global_end_time_today)
        ret,message = GetCheckResult(str_sql,"无看板机非人业务",False)
        if ret > int_ret:
            int_ret = ret
        str_message += ";"
        str_message += message
    return int_ret,str_message

#看板特性巡检
def CheckDataByKanbanMode():
    int_ret = common.EXIT_STATUS_INFO
    str_message = ""
    # 人脸业务巡检
    if global_bool_check_face_falg:
        # 组织sql
        str_sql = GenerateKanbanModeFaceSql(global_start_time_today, global_end_time_today)
        ret, message = GetCheckResult(str_sql, "有看板人脸业务",True)
        if ret > int_ret:
            int_ret = ret
        str_message += message
    # 结构化业务
    if global_bool_check_vas_falg:
        # 组织sql
        str_sql = GenerateKanbanModeVasAndAsSql(global_start_time_today, global_end_time_today,103)
        ret, message = GetCheckResult(str_sql, "有看板机非人业务",True)
        if ret > int_ret:
            int_ret = ret
        str_message += ";"
        str_message += message
    # 全结构化二次解析业务
    if global_bool_check_as_second_falg:
        # 组织sql
        str_sql = GenerateKanbanModeVasAndAsSql(global_start_time_today, global_end_time_today, 903)
        ret, message = GetCheckResult(str_sql, "有看板全结构化二次解析业务",True)
        if ret > int_ret:
            int_ret = ret
        str_message += ";"
        str_message += message
    # 全结构化全量解析业务
    if global_bool_check_as_all_falg:
        # 组织sql
        str_sql = GenerateKanbanModeVasAndAsSql(global_start_time_today, global_end_time_today, 901)
        ret, message = GetCheckResult(str_sql, "有看板全结构化全量解析业务",True)
        if ret > int_ret:
            int_ret = ret
        str_message += ";"
        str_message += message
    return int_ret, str_message


#参数初始化
def InitGloablParma(sys_argv):
    global global_db_name
    global global_db_user
    global global_db_password
    global global_db_host
    global global_db_port
    global global_bool_check_face_falg
    global global_bool_check_vas_falg
    global global_bool_check_as_second_falg
    global global_bool_check_as_all_falg
    #赋值
    global_db_name = sys_argv[1]
    global_db_user = sys_argv[2]
    global_db_password = sys_argv[3]
    global_db_host = sys_argv[4]
    global_db_port = sys_argv[5]
    try:
        # 尝试将输入转换为整数
        int_num = int(sys_argv[6])
        if int_num > 0:
            global_bool_check_face_falg = "True"  # param 6: 是否巡检人脸业务
        int_num = int(sys_argv[7])
        if int_num > 0:
            global_bool_check_vas_falg = "True"   # param 7: 是否巡检结构化业务 103
        int_num = int(sys_argv[8])
        if int_num > 0:
            global_bool_check_as_second_falg = "True"  # param 8: 是否巡检全结构化二次解析业务  903
        int_num = int(sys_argv[9])
        if int_num > 0:
            global_bool_check_as_all_falg = "True"  # param 9: 是否巡检全结构化全量解析业务 901
    except ValueError as e:
        info_message = "输入的值为【{}】,【{}】,【{}】,【{}】,转换int出现异常【{}】".format(
            sys_argv[6], sys_argv[7],sys_argv[8], sys_argv[9], e)
        common.Log(info_message)

#入参：
#param 0: python文件名称
#param 1: db_name = 'ias'
#param 2: user = 'postgres'
#param 3: password = 'Zhineng_1'
#param 4: host = '206.206.124.31'
#param 5: port = '5432 or 5442'
#param 6: 是否巡检人脸业务
#param 7: 是否巡检结构化业务 103
#param 8: 是否巡检全结构化二次解析业务  903
#param 9: 是否巡检全结构化全量解析业务 901
def MainCheck():
    if len(sys.argv) < 10:
        common.Log(sys.argv[0])
        print "MQ数据丢失检查失败，传参异常，参数列表长度：%d,小于最小限制10" % (len(sys.argv))
        sys.exit(common.EXIT_STATUS_WARNING)
    #初始化全局参数
    InitGloablParma(sys.argv)
    #判断是否需要执行巡检
    bool_ret,message_ret = IsSupportLossDataCheck()
    if False == bool_ret:
        print "当前巡检出现异常：%s" % (message_ret)
        sys.exit(common.EXIT_STATUS_WARNING)

    #根据是否具备看板特性执行巡检任务
    if IsSupportKanbanCheckMode(): #支持看板特性
        int_ret,message_ret=CheckDataByKanbanMode()
        if message_ret:
            print "MQ数据丢失巡检结果：%s" % (message_ret)
            sys.exit(int_ret)
    else:
        int_ret, message_ret = CheckDataByNoKanbanMode()
        if message_ret:
            print "MQ数据丢失巡检结果：%s" % (message_ret)
            sys.exit(int_ret)

### 执行脚本
MainCheck()