﻿# Python 2.7 示例脚本
import re
import os
import sys
import json
import csv
import codecs
import common

ERROR_NUM = 0
INFO_NUM = 0
WARNING_NUM = 1
# print(sys.stdout.encoding) 
charset = os.getenv('LANG') or os.getenv('LC_CTYPE')
# print("Charset from environment: ",charset)

### 格式化输出表头
def PrintExcelHead(headers_data):
    headers_length = sum(col[1] for col in headers_data)
    print "+%s+" % ("-" * (headers_length - 1))
    row_data=""
    for col_item in headers_data:
        item_name=(col_item[0])
        col_width=col_item[1]
        total_char_num = len(col_item[0])
        chinese_char_num = CountChineseCharsUnicode(col_item[0])
        english_char_num = total_char_num - 3 * chinese_char_num
        padding_nbsp_num = col_width - (english_char_num + 2 * chinese_char_num) - 1
        item_data = "|%s%s" % (item_name," " * padding_nbsp_num) 
        row_data += item_data
    print "%s|" % (row_data)
    return

### 格式化输出表格内容（待优化   ）
def PrintResult(headers_data, bodys_data):
    headers_col_num = len(headers_data) # 表头列数
    bodys_col_num = len(bodys_data) # 表格列数
    if headers_col_num !=  bodys_col_num :
        # 判断表格和表头列数是否一致
        print "headers_col_num: %d, bodys_col_num: %d" % (headers_col_num, bodys_col_num)
        return
    headers_length = sum(col[1] for col in headers_data) # 表头总宽度
    print "%s" % ("-" * (headers_length + 1)) # 打印行分隔线
    row_data=" "
    # 遍历每行数据的每一项
    for index in range(bodys_col_num):
        col_width=headers_data[index][1] #计算单元格宽度
        chinese_char_num = CountChineseCharsUnicode(bodys_data[index]) # 计算单元格中文字符数
        total_char_width_utf8 = len(common.GetUtf8Str(bodys_data[index])) # 计算单元格内字符总宽度
        english_char_num = total_char_width_utf8 - 3 * chinese_char_num # 计算单元格英文字符数
        total_char_width_col = chinese_char_num * 2 + english_char_num
        # print "total_char_width_col: %d  col_width: %d" % (total_char_width_col, col_width)
        #判断实际字符总宽度是否大于单元格宽度
        if total_char_width_col > col_width : 
            total_char_index = total_char_width_utf8 - 1
            have_handle_char_index=0
            end_char_index=77     
            tmp_flag=True # 是否是第一行
            item_datad=""
            while have_handle_char_index <= total_char_index : 
                read_end_index=77
                # 判断第78个字符是否是中文字符
                last_char_index=0
                if end_char_index > total_char_index : 
                    last_char_index = total_char_index
                else :
                    last_char_index = end_char_index
                last_char = common.GetUtf8Str(bodys_data[index])[last_char_index]
                # 寻找最后一个中文字符的边界
                if IsNotInstanceChar(last_char) : 
                    tmp_index=0
                    while True : 
                       instance_char=""
                       char_start_index = end_char_index-tmp_index
                       instance_char = common.GetUtf8Str(bodys_data[index])[char_start_index:char_start_index+3]
                       if IsNotInstanceChar(instance_char) : 
                           tmp_index += 1
                           continue
                       else : 
                           # 寻找到中文字符边界即退出
                           break
                    read_end_index=read_end_index+3-tmp_index
                end_index = have_handle_char_index + read_end_index 
                current_data = common.GetUtf8Str(bodys_data[index])[have_handle_char_index:end_index]
                current_length = len(common.GetUtf8Str(bodys_data[index])[have_handle_char_index:end_index])
                have_handle_char_index = have_handle_char_index + read_end_index
                end_char_index = end_char_index + read_end_index
                chinese_char_num = CountChineseCharsUnicode(current_data) # 计算单元格中文字符数
                english_char_num = current_length - 3 * chinese_char_num # 计算单元格英文字符数
                padding_nbsp_num = col_width - (english_char_num + 2 * chinese_char_num) - 1# 计算单元格需要补充的空格数
                if tmp_flag : 
                    tmp_check_result = "|%s%s|%s|\n" % (current_data," " * padding_nbsp_num, " " * (headers_data[3][1] - 1))
                    tmp_flag = False
                else :
                    if have_handle_char_index <= total_char_index : 
                        tmp_check_result = "|%s|%s|%s%s|%s|\n" % (" " * (headers_data[0][1] -1), " " * (headers_data[1][1] - 1), current_data, " " * padding_nbsp_num," " * (headers_data[3][1] - 1))
                    else : 
                        tmp_check_result = "|%s|%s|%s%s" % (" " * (headers_data[0][1] -1), " " * (headers_data[1][1] - 1), current_data, " " * padding_nbsp_num)
                item_datad += "%s" % (tmp_check_result) # 填充单元格数据
            row_data = "%s%s" % (row_data, item_datad)
        else : 
            padding_nbsp_num = col_width - (english_char_num + 2 * chinese_char_num) - 1 # 计算单元格需要补充的空格数
            item_data = "|%s%s" % (common.GetUtf8Str(bodys_data[index]), " " * padding_nbsp_num) # 填充单元格数据
            row_data = "%s%s" % (row_data, item_data) # 拼接所有单元格数据
    row_data = row_data.lstrip()
    print "%s|" % (row_data)
    return

### 格式化输出表尾
def PrintExcelEnd(headers_data):
    headers_length = sum(col[1] for col in headers_data)
    print "+%s+" % ("-" * (headers_length - 1))
    return
    
### 计数中文字符数
def CountChineseCharsUnicode(char_bytes):
    # print char_bytes
    str_length = 0
    try:
        unicode_text = char_bytes.decode('utf-8')
        chinese_char_pattern = re.compile(ur'[\u4e00-\u9fff\u3400-\u4dbf\uff00-\uffef\u3000-\u303f]')
        chinese_chars = chinese_char_pattern.findall(unicode_text)
        str_length = len(chinese_chars)
        # print len(chinese_chars)
    except UnicodeDecodeError:
        chinese_char_pattern = re.compile(ur'[\u4e00-\u9fff\u3400-\u4dbf\uff00-\uffef\u3000-\u303f]')
        chinese_chars = chinese_char_pattern.findall(char_bytes)
        str_length = len(chinese_chars)
    except UnicodeEncodeError:
        chinese_char_pattern = re.compile(ur'[\u4e00-\u9fff\u3400-\u4dbf\uff00-\uffef\u3000-\u303f]')
        # print char_bytes
        chinese_chars = chinese_char_pattern.findall(char_bytes)
        str_length = len(chinese_chars)
    # print str_length
    return str_length

def IsNotInstanceChar(char) :
    # print char
    try : 
        unicode_code = ord(unicode(char, 'utf-8'))
        # print "unicode_code: %s" % (unicode_code) 
    except TypeError:
        # print "TypeError"
        return True
    except UnicodeDecodeError:
        # print "UnicodeDecodeError"
        return True
    
### 读入并解析json文件
def ParseJsonFile() : 
    with open('/opt/iacheck/log/check_result.json', 'r') as file:
        json_bytes = file.read()
        json_bytes = common.GetUnicodeStr(json_bytes)
        data = json.loads(json_bytes)
        return data

def ParseCheckItem(json_arr_check_item) : 
    json_str = '{"CheckResult": "", "NeedHandle" : "无需处理"}'
    json_data = data = json.loads(json_str)
    int_check_status = 0
    str_warning_check_result = ""
    str_error_check_result = ""
    for index in range(len(json_arr_check_item)):
        json_item = json_arr_check_item[index]
        str_item_status = json_item["Status"]
        # print str_item_status
        if "OK" == str_item_status :
            if int_check_status <= 0 :
                global INFO_NUM
                INFO_NUM += 1
                int_check_status = 0
        elif "WARNING" == str_item_status : 
            if int_check_status <= 1 :
                global WARNING_NUM
                WARNING_NUM += 1
                int_check_status = 1
            # 解析警告信息
            json_warning_data = json_item["Message"]["WARNING"]
            for index_wrn in range(len(json_warning_data)) :
                str_warning_check_result = "%s%s%s" % (common.GetUnicodeStr(str_warning_check_result), json_warning_data[index_wrn],common.GetUnicodeStr("。")) 
        elif "ERROR" == str_item_status : 
            if int_check_status <= 2 :
                global ERROR_NUM
                ERROR_NUM += 1
                int_check_status = 2
            # 解析错误信息
            json_error_data = json_item["Message"]["ERROR"]
            for index_error in range(len(json_error_data)) :
                str_error_check_result = "%s%s%s" % (str_error_check_result, json_error_data[index_error], common.GetUnicodeStr("。")) 
    check_result = "%s %s" % (str_error_check_result, str_warning_check_result)
   
    if int_check_status == 0 : 
        json_data["NeedHandle"] = "无异常"
        json_data["CheckResult"] = "检查OK"
    elif int_check_status == 1 : 
        json_data["NeedHandle"] = "请按需处理"
        json_data["CheckResult"] = "WARNING: %s" % (str_warning_check_result)
    elif int_check_status == 2 : 
        json_data["NeedHandle"] = "影响业务，需要处理"
        if len(str_warning_check_result) == 0:
            json_data["CheckResult"] = "ERROR: %s" % (str_error_check_result)
        else : 
            json_data["CheckResult"] = "ERROR: %s  WARNING:%s" % (str_error_check_result, str_warning_check_result)
   
    return json_data

def PrintEndFlag() : 
    str_summer = "INFO: %d, WARINGIN: %d ERROR: %d" %  (INFO_NUM, WARNING_NUM, ERROR_NUM)
    padding_nbsp_front_length = int((144-len(str_summer) - 2) / 2)
    padding_nbsp_end_length = 144-padding_nbsp_front_length - len(str_summer)
    print "+%s+" % ("-" * 144)
    print "|%s|" % (" " * 144)
    print "|%s%s%s|" % (" " * padding_nbsp_front_length, str_summer, " " * padding_nbsp_end_length)
    print "|%s|" % (" " * 144)
    print "+%s+" % ("-" * 144)
    print "\n巡检报告路径：/opt/iacheck/log/check_report.xlsx\n"

### 定义表头
headers=( ("板卡类型", 20),
          ("板卡IP", 25),
          ("巡检结果", 80),
          ("是否需要处理",20))
# body_test = ("IAM", "127.0.0.1", "t f ip 00000000018a879a sp 00007f4e6512ee68 error 4 in iam[400000+1b8d000]】。", "否")
end_str = "%s\n%s 巡 检 结 束 %s\n%s" % ("*" * 146, "*" * 67, "*" * 66, "*" * 146)
RESET = '\033[0m'
GREEN = '\033[32m'      # 绿色
print("{}{}{}".format(GREEN, end_str, RESET))

PrintExcelHead(headers)

json_arr_data = ParseJsonFile()
json_arr_length = len(json_arr_data)
for index in range(json_arr_length):
    board_type = json_arr_data[index]["BoardCardType"]
    board_ip = json_arr_data[index]["IP"]
    json_arr_check_item = json_arr_data[index]["CheckItem"]
    json_check_result = ParseCheckItem(json_arr_check_item)
    board_check_result = json_check_result["CheckResult"]
    board_handle = json_check_result["NeedHandle"]
    bodys = (board_type, board_ip, board_check_result, board_handle)
    PrintResult(headers, bodys)
# PrintResult(headers, body_test)
PrintExcelEnd(headers)
PrintEndFlag()
