# coding=utf-8
#功能:输出各个任务路数并将路数是否分配对应的资源进行巡检
import subprocess
import sys
import common
import time
import urllib2
import urllib
import platform


global_db_name = 'ias'
global_db_user = 'postgres'
global_db_password = 'Zhineng_1'
global_db_host = '206.206.124.31'
global_db_port = common.GetIamPgPort()
#业务统计涉及的
# 定义业务类型常量
BussinesType_Unknown_V3 = 0                #未知
BussinesType_VAS_Video_V3 = 100           #结构化视频流
BussinesType_Vas_Pic_V3 = 103             #结构化图片流
BussinesType_FS_Video_V3 = 400            #人脸视频流
BussinesType_FS_Pic_V3 = 300              #人脸图片流
BussinesType_FS_FeatureRextract_V3 = 304  #人脸特征清洗
BussinesType_FS_PicSearch_V3 = 305        #人脸图搜
BussinesType_BA_Supervise_V3 = 200           #行为分析监管类型
BussinesType_BA_PersonAnalysis_V3 = 203     #行为分析人群分析
BussinesType_BA_Action_V3 = 202             #行为分析动作类型
BussinesType_BA_PersonNumStatic_V3 = 201    #行为分析人数统计
BussinesType_BA_Safety_V3 = 208            #行为分析安全
BussinesType_BA_CommonVideo_V5 = 210             #昆仑5、GPU、爱芯行为分析通用
BussinesType_AS_Video_V3 = 902              #全结构化视频流
BussinesType_AS_PicSingle_V3 = 903          #全结构化二次解析
BussinesType_AS_PicAll_V3 = 901             #全结构化全量解析

#定义行为分析的业务列表
ba_business_types = {
        BussinesType_BA_Supervise_V3,
        BussinesType_BA_PersonAnalysis_V3,
        BussinesType_BA_Action_V3,
        BussinesType_BA_PersonNumStatic_V3,
        BussinesType_BA_Safety_V3,
        BussinesType_BA_CommonVideo_V5
    }
# 定义数值枚举（数值在前）
global_bussines_value_enums = {
    BussinesType_VAS_Video_V3: "结构化视频流",
    BussinesType_FS_Video_V3: "人脸视频流",
    BussinesType_Vas_Pic_V3: "结构化图片流",
    BussinesType_FS_Pic_V3: "人脸图片流",
    BussinesType_BA_CommonVideo_V5: "行为分析视频流",  #行为分析视频流，合一版本业务类型
    BussinesType_AS_Video_V3: "全结构化视频流",
    BussinesType_AS_PicAll_V3: "图片流全量解析",
}
#业务类型对应的任务数的map
global_business_taskNum = {
    BussinesType_VAS_Video_V3: 0,
    BussinesType_FS_Video_V3: 0,
    BussinesType_Vas_Pic_V3: 0,
    BussinesType_FS_Pic_V3: 0,
    BussinesType_BA_CommonVideo_V5: 0,  # 行为分析视频流，合一版本业务类型
    BussinesType_AS_Video_V3: 0,
    BussinesType_AS_PicAll_V3: 0,
}
#业务类型对应的资源数map
global_business_resource = {
    BussinesType_VAS_Video_V3: 0,
    BussinesType_FS_Video_V3: 0,
    BussinesType_Vas_Pic_V3: 0,
    BussinesType_FS_Pic_V3: 0,
    BussinesType_BA_CommonVideo_V5: 0,  # 行为分析视频流，合一版本业务类型
    BussinesType_AS_Video_V3: 0,
    BussinesType_AS_PicAll_V3: 0,
}

#获取总的资源分配情况，不区分板卡
#处理汇总数据
def handelStaticData(engine_version, task_type, business_type, count):
    global global_business_resource
    # 将行为分析业务类型转换
    if business_type in ba_business_types:
        business_type = BussinesType_BA_CommonVideo_V5
    if business_type == BussinesType_AS_PicSingle_V3: #全结构化二次解析，也是结构化图片流任务，两者通用
        business_type = BussinesType_Vas_Pic_V3
    # 缓存业务类型的单元数
    if int(business_type) in global_business_resource:
        global_business_resource[int(business_type)] = global_business_resource[int(business_type)] + int(count)

#处理数据
def handleSqlLiteData(str_lines):
    for line in str_lines:
        # 去除行首和行尾的空白字符
        line = line.strip()
        # 检查行是否为空
        if not line:
            continue
        # 尝试拆分行
        parts = line.split('|')
        # 确保拆分后的部分数量正确
        if len(parts) != 4:
            info_message = "获取的数据，按照|分割，不足4个字段长度: %s" % (line)
            common.Log(info_message)
            continue
        # 处理数据
        engine_version, task_type, business_type, count = parts
        try:
            #汇总统计数据，累加使用的
            handelStaticData(engine_version, task_type, business_type, count)
        except Exception as e:
            print("资源分配获取错误: {}，巡检异常".format(e))
            sys.exit(common.EXIT_STATUS_WARNING)

#获取sqlite数据
def getSqllite3Data(str_sql):
    bool_ret=False
    str_ret=""
    #获取单行sql
    sql_query_single_line = str_sql.replace('\n', ' ').strip()
    #调用sql命令
    os_type = platform.system()
    if os_type == 'Windows':
        sqlite_command = 'sqlite3.exe {} "{}"'.format("ias.db", sql_query_single_line)
    elif os_type == 'Linux':
        sqlite_command = 'sqlite3 {} "{}"'.format("/opt/wise/ia12k/db/ias.db", sql_query_single_line)
    info_message = "组织的sql命令为：%s" % (sql_query_single_line)
    common.Log(info_message)
    #获取结果
    try:
        # 使用 subprocess.Popen 执行命令
        process = subprocess.Popen(sqlite_command, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True,universal_newlines=True)
        # 获取输出和错误信息
        stdout, stderr = process.communicate()
        if process.returncode != 0:
            info_message = "Error executing SQLite command: %s" % (common.GetUtf8Str(stderr))
            common.Log(info_message)
            print "读取sqllie数据库异常【%s】,巡检异常" % (common.GetUtf8Str(stderr))
            sys.exit(common.EXIT_STATUS_WARNING)
        else:
            # 解析输出
            bool_ret = True
            str_ret = stdout
    except Exception as e:
        info_message = "Error executing SQLite command，An error occurred: %s" % (common.GetUtf8Str(e))
        common.Log(info_message)
        print "读取sqllie数据库异常【%s】,巡检异常" % (common.GetUtf8Str(e))
        sys.exit(common.EXIT_STATUS_WARNING)
    return bool_ret,str_ret

def getAllAssignResourceInfo():
    #组织sql
    # 编写 SQL 查询
    sql_query = """
SELECT 
    engine_version,
    task_type, 
    business_type, 
    COUNT(*) AS count
FROM 
    ia_engine
WHERE 
    id LIKE '%#%'
    AND business_type != 1
GROUP BY 
    engine_version,
    task_type,
    business_type;
    """
    #获取数据
    bool_ret,str_ret = getSqllite3Data(sql_query)
    #组织数据
    # 解析输出
    output_lines = str_ret.strip().split('\n')
    info_message = "获取的数据 %s" % (output_lines)
    common.Log(info_message)
    handleSqlLiteData(output_lines)


#获取各个业务模块是否存在资源
def HandleSqlData(sql_data):
    int_ret = 0
    #处理sql数据
    lines = sql_data.split('\r\n')
    for line in lines:
        if line != "":
            try:
                # 尝试将字符串转换为整数
                int_ret = int(line.strip())
                break
            except ValueError:
                int_ret = -1
                # 如果转换失败，打印错误信息
                info_message = "SQL获取的数值为【{}】，转换整数失败".format(line)
                common.Log(info_message)
                break
    return int_ret
#人脸相关
#获取人脸图片流有效任务数:查询tbl_iafs_third_party_ipc_info，stream_type值为2和3的数量（1：视频流；2：图片流；3：人证设备）
def getFaPicTasKNum():
    int_num = -1
    #组织sql
    sql_query = '''
        SELECT 
            COUNT(*) AS count_stream_type_2_or_3
        FROM 
            public.tbl_iafs_third_party_ipc_info
        WHERE 
            stream_type IN (2, 3) AND task_status != 1;
            '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    #读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取人脸图片流任务数的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    #返回结果
    return int_num


#获取人脸离线视频任务分片数：
# 老版本：tbl_iafs_task 表task_type=7的；
# 新版本：tbl_video_analysis_task_info总表、tbl_video_frag_task_info分表
# 总表中的task_type
# FaLocalTask = 1, 人脸本地文件任务
# VASLocalTask = 2, VAS本地文件任务
# ASLocalTask = 3, 全结构化
def getFaLocalVideoTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
        WITH task_count_1 AS (
            SELECT COUNT(*) AS count_1
            FROM public.tbl_iafs_task
            WHERE task_type = 7
        ),
        task_count_2 AS (
            SELECT COUNT(*) AS count_2
            FROM tbl_video_analysis_task_info vat
            JOIN tbl_video_frag_task_info vft ON vat.task_id = vft.task_id
            WHERE vat.task_type = 1
        )
        SELECT (SELECT count_1 FROM task_count_1) + (SELECT count_2 FROM task_count_2) AS total_count;
        '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取人脸离线视频任务任务数的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num


#获取人脸中心录像分片数：tbl_iafs_task 表task_type=10的；
def getFaVideoRecordTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
        SELECT COUNT(*) AS count_task_type_10
        FROM public.tbl_iafs_task
        WHERE task_type = 10;
        '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取人脸中心录像任务数的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num


#获取人脸实况任务数：tbl_iafs_third_party_ipc_info 表stream_type=1的；
def getFaRealVideoTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
            SELECT COUNT(*) AS count_task_type
            FROM 
            public.tbl_iafs_third_party_ipc_info
            WHERE 
            stream_type = 1 AND task_status != 1;
            '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取人脸实况任务数的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#结构化相关
#获取结构化图片流任务数：#获取全结构化二次解析图片流任务数(不区分结构化，只读取一次即可):tbl_iavas_pic_task表中，mode = 2 （VasMode::IaVasPicTask）
def getVasPicVideoTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
        SELECT COUNT(*) AS count_mode
        FROM public.tbl_iavas_pic_task
        WHERE mode = 2;
        '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取结构化二次解析任务数的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#获取结构化离线视频任务分片数：
# 新版本：tbl_video_analysis_task_info总表、tbl_video_frag_task_info分表
# 总表中的tasl_type
# FaLocalTask = 1, 人脸本地文件任务
# VASLocalTask = 2, VAS本地文件任务
# ASLocalTask = 3, 全结构化本地文件任务
# 旧版本：tbl_local_file_vas_task总表、tbl_local_file_vas_task_frag分表
def getVasLocalVideoTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
        SELECT SUM(count_value) AS total_count
        FROM (
            SELECT COUNT(*) AS count_value
            FROM public.tbl_local_file_vas_task_frag
            UNION ALL
            SELECT COUNT(*) AS count_value
            FROM tbl_video_analysis_task_info vat
            JOIN tbl_video_frag_task_info vfti ON vat.task_id = vfti.task_id
            WHERE vat.task_type = 2
        ) AS counts;
        '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取结构化离线视频任务数的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#获取结构化实况任务分片数：tbl_iavas_real_video_task中mode = 0 （VasMode::IaStructTask）
def getVasRealVideoTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
            SELECT COUNT(*) AS count_mode
            FROM public.tbl_iavas_real_video_task
            WHERE mode = 0;
            '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取结构化实况任务的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#获取结构化中心录像分片数：获取tbl_iavas_video_record_task表中mode为0的taskid，然后读取tbl_iavas_video_record_frag关联的总任务数
def getVasVideoRecordTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
        SELECT COUNT(*) AS total_count
        FROM public.tbl_iavas_video_record_frag
        WHERE task_id IN (
            SELECT task_id
            FROM public.tbl_iavas_video_record_task
            WHERE mode = 0
        );
        '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取结构化中心录像的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num


#全结构化相关
#获取全结构化全量解析图片流任务数:tbl_iavas_pic_task表中，mode = 4 （VasMode::IaPanoramaPicTask）
def getAsPanoramPicTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
            SELECT COUNT(*) AS count_mode
            FROM public.tbl_iavas_pic_task
            WHERE mode = 4;
            '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取全结构化全量解析任务数的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#获取全结构化二次解析图片流任务数(不区分结构化，只读取一次即可):tbl_iavas_pic_task表中，mode = 2 （VasMode::IaVasPicTask）
def getAsVasPicTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
            SELECT COUNT(*) AS count_mode
            FROM public.tbl_iavas_pic_task
            WHERE mode = 2;
            '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取结构化二次解析任务数的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#获取全结构化离线视频任务分片数
# 新版本：tbl_video_analysis_task_info总表、tbl_video_frag_task_info分表
# 总表中的tasl_type
# FaLocalTask = 1, 人脸本地文件任务
# VASLocalTask = 2, VAS本地文件任务
# ASLocalTask = 3, 全结构化本地文件任务
def getAsLocalVideoTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
            SELECT COUNT(*) AS total_count
            FROM public.tbl_video_frag_task_info
            WHERE task_id IN (
                SELECT task_id
                FROM public.tbl_video_analysis_task_info
                WHERE task_type = 3
            );
            '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取全结构化离线视频任务的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#获取全结构化实况任务数 tbl_iavas_real_video_task中mode = 5 （VasMode::IaPanoramaVideoTask）
def getAsRealVideoTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
                SELECT COUNT(*) AS count_mode
                FROM public.tbl_iavas_real_video_task
                WHERE mode = 5;
                '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取全结构化实况任务的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#获取全结构化中心录像分片数 获取tbl_iavas_video_record_task表中mode为5的taskid，然后读取tbl_iavas_video_record_frag关联的总任务数
def getAsVideoRecordTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
            SELECT COUNT(*) AS total_count
            FROM public.tbl_iavas_video_record_frag
            WHERE task_id IN (
                SELECT task_id
                FROM public.tbl_iavas_video_record_task
                WHERE mode = 5
            );
            '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取结构化中心录像的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#行为分析相关
#获取行为分析的任务数：tbl_iaba_task表
def getBaRealVideoTasKNum():
    int_num = -1
    # 组织sql
    sql_query = '''
        SELECT COUNT(*) AS total_count
        FROM public.tbl_iaba_task;
        '''
    sql_query_single_line = sql_query.replace('\n', ' ').strip()
    # 读取sql数据
    # 获取sql数据并解析数据
    bool_ret, str_data = common.PorcessPgSqlCommand(global_db_name, global_db_user, global_db_host, global_db_port,
                                                    global_db_password, sql_query_single_line)
    if False == bool_ret:
        str_message = "获取行为分析的sql数据失败"
        common.Log(str_message)
    else:
        if str_data:
            int_num = HandleSqlData(str_data)
    # 返回结果
    return int_num

#参数初始化
def InitGloablParma(sys_argv):
    global global_db_name
    global global_db_user
    global global_db_password
    global global_db_host
    global global_db_port
    #赋值
    global_db_name = sys_argv[1]
    global_db_user = sys_argv[2]
    global_db_password = sys_argv[3]
    global_db_host = sys_argv[4]
    global_db_port = sys_argv[5]

#获取各个业务对应的任务数
def getTaskNum():
    global global_business_taskNum
    str_ret = ""
    int_ret = common.EXIT_STATUS_INFO
    #获取任务数
    VasPicVideoTasKNum = getVasPicVideoTasKNum()
    VasLocalVideoTasKNum = getVasLocalVideoTasKNum()
    VasRealVideoTasKNum = getVasRealVideoTasKNum()
    VasVideoRecordTasKNum = getVasVideoRecordTasKNum()

    FaPicTasKNum = getFaPicTasKNum()
    FaVideoRecordTasKNum = getFaVideoRecordTasKNum()
    FaLocalVideoTasKNum = getFaLocalVideoTasKNum()
    FaRealVideoTasKNum = getFaRealVideoTasKNum()

    AsVasPicTasKNum = getAsVasPicTasKNum()
    AsPanoramPicTasKNum = getAsPanoramPicTasKNum()
    AsVideoRecordTasKNum = getAsVideoRecordTasKNum()
    AsLocalVideoTasKNum = getAsLocalVideoTasKNum()
    AsRealVideoTasKNum = getAsRealVideoTasKNum()

    BaRealVideoTasKNum = getBaRealVideoTasKNum()

    #组织返回的信息
    str_ret = "结构化图片流任务数：%d,结构化离线视频分片任务数：%d,结构化实况任务数：%d,结构化录像分片任务数：%d;" % (
        VasPicVideoTasKNum, VasLocalVideoTasKNum, VasRealVideoTasKNum, VasVideoRecordTasKNum)
    str_ret += "全结构化全量解析图片流任务数：%d,全结构化离线视频分片任务数：%d,全结构化实况任务数：%d,全结构化录像分片任务数：%d;" % (
        AsPanoramPicTasKNum, AsLocalVideoTasKNum, AsRealVideoTasKNum, AsVideoRecordTasKNum)
    str_ret += "人脸图片流任务数：%d,人脸离线视频分片任务数：%d,人脸实况任务数：%d,人脸录像分片任务数：%d;" % (
        FaPicTasKNum, FaLocalVideoTasKNum, FaRealVideoTasKNum, FaVideoRecordTasKNum)
    str_ret += "行为分析任务数：%d;" % (BaRealVideoTasKNum)
    common.Log(str_ret)

    if (VasPicVideoTasKNum >= 0 and VasLocalVideoTasKNum >= 0 and VasRealVideoTasKNum >= 0 and VasVideoRecordTasKNum >= 0 and
        FaPicTasKNum >= 0 and FaVideoRecordTasKNum >= 0 and FaLocalVideoTasKNum >= 0 and FaRealVideoTasKNum >= 0 and
        AsVasPicTasKNum >= 0 and AsPanoramPicTasKNum >= 0 and AsVideoRecordTasKNum >= 0 and AsLocalVideoTasKNum >= 0 and AsRealVideoTasKNum >= 0 and
        BaRealVideoTasKNum >= 0):
        #汇总业务信息
        global_business_taskNum[BussinesType_VAS_Video_V3] = VasLocalVideoTasKNum + VasRealVideoTasKNum + VasVideoRecordTasKNum
        global_business_taskNum[BussinesType_Vas_Pic_V3] = VasPicVideoTasKNum + AsVasPicTasKNum

        global_business_taskNum[BussinesType_FS_Video_V3] = FaVideoRecordTasKNum + FaLocalVideoTasKNum + FaRealVideoTasKNum
        global_business_taskNum[BussinesType_FS_Pic_V3] = FaPicTasKNum

        global_business_taskNum[BussinesType_BA_CommonVideo_V5] = BaRealVideoTasKNum

        global_business_taskNum[BussinesType_AS_Video_V3] = AsVideoRecordTasKNum + AsLocalVideoTasKNum + AsRealVideoTasKNum
        global_business_taskNum[BussinesType_AS_PicAll_V3] = AsPanoramPicTasKNum
        return int_ret,str_ret
    else:
        str_ret1 = "任务列表数获取数量存在-1，异常，任务数详情如下："
        str_ret = str_ret1 + str_ret
        global_business_taskNum.clear()
        int_ret = common.EXIT_STATUS_WARNING
        return int_ret,str_ret


#比较任务和资源是否匹配
def check_maps(task_num_map, resource_map):
    str_ret = ""
    int_ret = common.EXIT_STATUS_INFO
    for key in task_num_map:
        task_num = task_num_map[key]
        resource_num = resource_map[key]
        if (task_num > 0 and resource_num <= 0) :
            str_bussiness_name = global_bussines_value_enums[int(key)]
            str_ret += "业务类型【%s】，任务数【%d】，分配的资源数【%d】,异常；" % (str_bussiness_name,task_num,resource_num)
            int_ret = common.EXIT_STATUS_ERROR
        else:
            str_bussiness_name = global_bussines_value_enums[int(key)]
            str_ret += "业务类型【%s】，任务数【%d】，分配的资源数【%d】,正常；" % (str_bussiness_name, task_num, resource_num)
    return int_ret,str_ret

def check_taskNum_resourceNum():
    # 检查
    int_ret, str_ret = check_maps(global_business_taskNum, global_business_resource)
    common.Log(str_ret)
    return int_ret, str_ret
#主函数
#入参：
#param 0: python文件名称
#param 1: db_name = 'ias'
#param 2: user = 'postgres'
#param 3: password = 'Zhineng_1'
#param 4: host = '206.206.124.31'
#param 5: port = '5432 or 5442'
def mainCheck():
    if len(sys.argv) < 6:
        common.Log(sys.argv[0])
        print "任务和资源匹配巡检失败，传参异常，参数列表长度：%d,小于最小限制10" % (len(sys.argv))
        sys.exit(common.EXIT_STATUS_WARNING)
    # 初始化全局参数
    InitGloablParma(sys.argv)
    #获取业务资源类型
    getAllAssignResourceInfo()
    str_messgae = "资源分配详情："
    for key in global_business_resource:
        resource_num = global_business_resource[int(key)]
        str_bussiness_name = global_bussines_value_enums[int(key)]
        str_messgae += "业务类型【%s】，分配的资源数【%d】；" % (str_bussiness_name,resource_num)
    common.Log(str_messgae)
    #获取各个表的任务数量
    int_ret1,str_ret1 = getTaskNum()
    if len(global_business_taskNum) == 0:
        print str_ret1
        sys.exit(int_ret1)
    #获取任务数和资源匹配
    int_ret2,str_ret2 = check_taskNum_resourceNum()
    #合并信息
    str_ret = "任务数详情如下：[%s] 资源分配和任务数对应详情如下：[%s]" % (str_ret1,str_ret2)
    if int_ret1 >= int_ret2:
        int_ret = int_ret1
    else:
        int_ret = int_ret2
    #将授权新返回
    print str_ret
    sys.exit(int_ret)

mainCheck()